-- QUERY GET GRANTS FOR A TABLE
SELECT grantee, string_agg(privilege_type, ', ') AS privileges
FROM information_schema.role_table_grants 
WHERE table_name='%param$' --{ votre table }--
GROUP BY grantee;	
	
	
-- QUERY GET TABLE DESCRIPTION
SELECT  
    f.attnum AS number, f.attname AS name, f.attnum,  
    f.attnotnull AS notnull, pg_catalog.format_type(f.atttypid,f.atttypmod) AS type, com.description as comment,
    CASE  
        WHEN p.contype = 'p' THEN 't' 
        ELSE 'f' 
    END AS primarykey, 
    CASE  
        WHEN p.contype = 'u' THEN 't' 
        ELSE 'f'
    END AS uniquekey,
    CASE
        WHEN p.contype = 'f' THEN g.relname
    END AS foreignkey,
    CASE
        WHEN p.contype = 'f' THEN p.confkey
    END AS foreignkey_fieldnum,
    CASE
        WHEN p.contype = 'f' THEN g.relname
    END AS foreignkey,
    CASE
        WHEN p.contype = 'f' THEN p.conkey
    END AS foreignkey_connnum,
    CASE
        WHEN f.atthasdef = 't' THEN d.adsrc
    END AS default
FROM pg_attribute f  
    JOIN pg_class c ON c.oid = f.attrelid 
    JOIN pg_type t ON t.oid = f.atttypid 
    LEFT JOIN pg_attrdef d ON d.adrelid = c.oid AND d.adnum = f.attnum 
    LEFT JOIN pg_namespace n ON n.oid = c.relnamespace  
    LEFT JOIN pg_constraint p ON p.conrelid = c.oid AND f.attnum = ANY (p.conkey) 
    LEFT JOIN pg_class AS g ON p.confrelid = g.oid 
    LEFT JOIN pg_description com on (c.oid = com.objoid AND f.attnum = com.objsubid)
WHERE c.relkind = 'r'::char  
    AND n.nspname = '%param$'  --{ votre schema }--
    AND c.relname = '%param$'  --{ votre table }--
    AND f.attnum > 0 ORDER BY number ;
	
	
-- QUERY GET DATABASES SIZE
SELECT
    pg_database.datname,
    pg_size_pretty(pg_database_size(pg_database.datname)) AS size
    FROM pg_database ORDER BY pg_database.datname ;
	
	
-- QUERYS GET INFORMATIONS ABOUT FUNCTIONS
SELECT COUNT(*)>0 AS present, COUNT(*) AS Nbre FROM pg_proc WHERE proname LIKE '%cross%'::text;
SELECT proname FROM pg_proc WHERE proname LIKE '%cross%'::text;
SELECT * FROM pg_proc WHERE proname = '%param$' --{votre function}-- ;
	
	
-- QUERYS GET INFORMATIONS ABOUT TYPEGEOM IN POSTGIS
SELECT * FROM information_schema.columns;

SELECT postgis_typmod_type(a.atttypmod) AS typegeom FROM pg_attribute a GROUP BY typegeom ORDER BY typegeom ;

SELECT * FROM pg_type AS t WHERE t.typname LIKE '%polygon%' ;
	
	
-- QUERY GET NOT VALID GEOMETRY
SELECT geom, ST_IsValidReason(geom) FROM %param$ --{ votre schema.table }--
WHERE NOT ST_IsValid(geom);
