# -*- coding:utf-8 -*-
from qgis.core import (Qgis, QgsApplication, QgsFeature, QgsLayerTreeGroup, QgsProject, QgsProviderRegistry, QgsRasterLayer,
                       QgsVectorFileWriter, QgsWkbTypes)
from qgis.gui import (QgsCollapsibleGroupBox, QgsDateTimeEdit)

from qgis.PyQt.QtCore import (QDate, QFile, QFileInfo, QLocale, QRegExp, QSettings, QSize, QT_VERSION, Qt)
from qgis.PyQt.QtGui import (QBrush, QColor, QFont, QIcon, QStandardItem, QStandardItemModel)
from qgis.PyQt.QtWidgets import (QAbstractItemView, QApplication, QComboBox, QCommandLinkButton,
                                 QFileDialog, QGroupBox, QHeaderView, QLineEdit, QListWidgetItem, QPushButton,
                                 QRadioButton, QTableView, QTableWidget, QTableWidgetItem, QTextEdit, QTreeWidget, QTreeWidgetItem)
from qgis.PyQt.QtXml import QDomDocument

from qsphere.qsphere_objmaker import (myCheckBox, myComboBox, myPushButton, MySimpleWidgetLineEdit, MySimpleWidgetLineEditST,
                              mySpinBox, myTableWidget, myTextEdit, myUserComboBox, myWebComboBox, MyWidgetLineEdit)

from ast import literal_eval
from codecs import open as codecsopen
from configparser import ConfigParser
from datetime import datetime
from functools import reduce
from math import (floor, log, pow)
from numpy import linspace as nplinspace
from os import walk
from os.path import (basename, dirname, exists, isfile, join, splitext)

try:
    from osgeo.gdal import Open as gdalopen
    from osgeo.gdal import GetDriver as gdal_GetDriver
    from osgeo.gdal import GetDriverCount as gdal_GetDriverCount
    from osgeo.gdal import GetDriverByName as gdal_GetDriverByName
    from osgeo.gdal import (DMD_LONGNAME, DMD_MIMETYPE, DMD_EXTENSION)
    from osgeo.ogr import GetDriver as ogr_GetDriver
    from osgeo.ogr import GetDriverCount as ogr_GetDriverCount
except:
    from gdal import Open as gdalopen
    from gdal import GetDriver as gdal_GetDriver
    from gdal import GetDriverCount as gdal_GetDriverCount
    from gdal import GetDriverByName as gdal_GetDriverByName
    from gdal import (DMD_LONGNAME, DMD_MIMETYPE, DMD_EXTENSION)
    from ogr import GetDriver as ogr_GetDriver
    from ogr import GetDriverCount as ogr_GetDriverCount

from owslib.namespaces import Namespaces
#from pyodbc import dataSources as pyodbcdataSources
from random import sample
import requests

import socket
from string import (ascii_letters, digits)
from sys import path as syspath
from textwrap import fill as textwrapfill
from threading import Thread, enumerate
from time import sleep
from urllib.parse import unquote
from urllib.request import (Request, build_opener, urlopen, URLError, HTTPError)
from webbrowser import open as webbrowseropen
from xml.dom.minidom import parseString
#TEST
import psycopg2
#TEST
UPDATE_INTERVAL = 0.01


html =  """
        <!DOCTYPE html><html><head><meta charset='utf-8'/></head> 
        <style>
        table {border-spacing: 0px; width: 100%%}
        th, td {padding: 5px 30px 5px 10px;border-spacing: 0px;font-size: 90%%;margin: 0px;}
        th, td.idiot {color: #737476;text-align: left; background-color: #e0e9f0; border-top: 1px solid #f1f8fe;border-bottom: 1px solid #cbd2d8; border-right: 1px solid #cbd2d8;}
        tr.comment th {color: #90b4d6;background-color: #FFF; border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6; text-align: left; text-shadow: -1px -1px 1px #666; letter-spacing: 0.15em;}
        tr.head th {vertical-align: text-top; color: #fff; background-color: #90b4d6; border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe; border-top: 1px solid #90b4d6; text-align: left; text-shadow: -1px -1px 1px #666; letter-spacing: 0.15em;}
        tr.head th:first-child {-webkit-border-top-left-radius: 5px; -moz-border-radius-topleft: 5px; border-top-left-radius: 5px;}
        tr.head th:last-child {-webkit-border-top-right-radius: 5px; -moz-border-radius-topright: 5px; border-top-right-radius: 5px;}
        tr.headTitle th {font-size: 150%%; color: #fff;background-color: #00b4FF; border-bottom: 2px solid #547ca0; border-right: 1px solid #749abe;border-top: 1px solid #90b4d6; text-align: center;text-shadow: -1px -1px 1px #666;letter-spacing: 0.15em; vertical-align: middle;}
        tr.headTitle th:first-child {-webkit-border-top-left-radius: 10px; -moz-border-radius-topleft: 10px; border-top-left-radius: 10px; -webkit-border-bottom-left-radius: 10px; -moz-border-radius-bottomleft: 10px; border-bottom-left-radius: 10px;}
        tr.headTitle th:last-child {-webkit-border-top-right-radius: 10px; -moz-border-radius-topright: 10px; border-top-right-radius: 10px; -webkit-border-bottom-right-radius: 10px; -moz-border-radius-bottomright: 10px; border-bottom-right-radius: 10px;}
        td {text-shadow: 1px 1px 1px #fff;}
        tr.even td, tr.even th {background-color: #e8eff5;}
        body {font-family: Arial, Verdana, sans-serif;font-size: 100%%;}
        tr.comment {color: #90b4d6;background-color: #FFF; border-bottom: 2px solid #547ca0; border-right: 1px solid #749abe; border-top: 1px solid #90b4d6; text-align: left; text-shadow: -1px -1px 1px #666;letter-spacing: 0.15em;}
        </style>
        <body>
        %s
        </body>
        </html>
        """


UPDATE_INTERVAL = 0.01

def iterateTreeWidget(html, currentItem, ancestor, nbTab):
  tab = ""
  nbTab+= 1
  for k in range(nbTab): tab+="\t"

  newFlag = False  
  separator = "" if currentItem.childCount() == 1 and not currentItem.child(0).text(0).startswith("gmd:") and not currentItem.child(0).text(0).startswith("gco:") else "\n"
  
  if currentItem.text(0).startswith("gmd:") or currentItem.text(0).startswith("gco:") :
      html+= "%s<%s%s>%s" % (tab, currentItem.text(0), currentItem.toolTip(0), separator)
  else : html+= "%s" % currentItem.text(0); newFlag = True ;
  for i in range(currentItem.childCount()) : html = iterateTreeWidget(html, currentItem.child(i), ancestor, nbTab)
  try :
      if ancestor != currentItem.parent() :
          if newFlag : html+= "</%s>\n" % (currentItem.parent().text(0))
          else :
              tab= ""
              for k in range(nbTab-1): tab+="\t"
              html+= "%s</%s>\n" % (tab, currentItem.parent().text(0))
  except : pass 
  return html


def msgBadFileXml(self):
    msg = QApplication.translate("QSphere","Invalid XML document !")
    sendMsg(self, "information" , msg, Qgis.Warning, self.duration_warning)  

def saveResultsInFile(self, initDir, vectorLayer):
        if initDir == "" : initDir == dirname(__file__)
        initDir = correctPath(initDir)
        title = QApplication.translate("QSphere","Save search files results")
        dlgFile = QFileDialog(self, title)
        elt0 = QApplication.translate("QSphere","files").title()
        dlgFile.setNameFilters(("%s QSphere (*.dbf)" % (elt0),)) 
        dlgFile.setDefaultSuffix("dbf")
        dlgFile.setViewMode(QFileDialog.Detail)
        dlgFile.setAcceptMode(QFileDialog.AcceptSave)

        fixeLabelsFileDialog(self, dlgFile, 1, True)
       
        dlgFile.setDirectory(initDir)
        
        if dlgFile.exec_():
            fileName = dlgFile.selectedFiles()[0]
            fileName = splitext(fileName)[0]
            error = QgsVectorFileWriter.writeAsVectorFormat(vectorLayer, fileName, "UTF-8", vectorLayer.crs(), "ESRI Shapefile")
            if error[0] == 0 : 
                    title = QApplication.translate("QSphere","Save as a file") 
                    msg = QApplication.translate("QSphere","The metadata record was saved as")
                    sendMsg(self, title , "%s :<br><u><i>%s</i></ul>" % (msg, fileName), Qgis.Info, self.duration_info)
            else :
                    title = QApplication.translate("QSphere","Warning")
                    msg = QApplication.translate("QSphere","Error")
                    sendMsg(self, title , "%s : %s<br>[%s]" % (msg, fileName, error[1]), Qgis.Warning, 5)

        return initDir


def patternZipPostalCode(self, sender):
        if sender.objectName() == "" : return
        senderNameId = sender.objectName().split("_")[0]
        row = int(sender.objectName().split("_")[2])
        obj = getWidget(self, senderNameId)
        if obj != None :
            cellWidget = obj.cellWidget(row, 4)
            if cellWidget == None : return
            key = sender.currentText()
            oldText = cellWidget.text()
            if dicoHasKey(self.listCountriesCode, key) :                
                cellWidget.setInputMask("")
                cellWidget.setInputMask(self.listCountriesCode[key][1])
                cellWidget.regex = QRegExp(r"%s" % (self.listCountriesCode[key][0]), Qt.CaseSensitive)
            else :
                cellWidget.setInputMask("")
                cellWidget.setInputMask("XXXxxxxxxx;X")
                cellWidget.regex = QRegExp(r"(^+[a-zA-Z_0-9\s]{3,10}$)", Qt.CaseSensitive)          
            cellWidget.setText(oldText)


def badNetwork(url):
    socket.setdefaulttimeout(3)
    badNetwork = False
    try : response = urlopen( url )
    except HTTPError as e : pass
    except URLError as e : pass
    else : badNetwork = True
    return badNetwork


def notEmptyElts(collection):
    notEmptyElts, counter, nbProperties = False, 0, 0
    emptyElts = ('', 'None', None, ['None'])
    collection = collection[0]
    if type(collection) in (list, tuple) :
       for elt in collection :
           if not elt in emptyElts : notEmptyElts = True; counter+= 1 ;
    elif type(collection) == dict :
        for key in collection :
           if not collection[key] in emptyElts :  notEmptyElts = True; counter+= 1;
    return notEmptyElts, counter, len(collection)
    

def notEmptyList(listIn):
    notEmptyList = False
    for elt in listIn :
        if elt!= '' : notEmptyList = True; break ; 
    return notEmptyList


def fixeValuesForExtent(self, widget, line, emprise, isTableWidget, geolocalisator):
        if isTableWidget :
            if not geolocalisator :
                affectEmprise = (float(emprise[3]), float(emprise[1]), float(emprise[0]), float(emprise[2]))
                for i in range(4): widget.cellWidget(line, i).setValue(affectEmprise[i])
            else :
                for i in range(4): widget.cellWidget(line, i).setValue(emprise[i])    
        else :
            i = 0
            for child in self.Metadata.children():
                if child.metaObject().className() == "mySpinBox" :
                   child.setValue(emprise[i]) 
                   i+= 1


def loopNodes(node, subDico):
    sub_node = node.firstChild()
    sub_prop = sub_node.toElement()

    if sub_prop.isNull() :
       subDico[node.nodeName()] = sub_prop.text()
    else :
        sub_node = node.firstChild()
        while sub_node.isNull() is False:
              subsubDico = {}
              sub_prop = sub_node.toElement()      
              subDico[sub_node.nodeName()] = sub_prop.text()
              subsubDico = loopNodes(sub_node, subsubDico)
              sub_node = sub_node.nextSibling()
    return subDico      

def introspectNodeXml(dataDict, node, nameNode, parentTreeWidgetItem):
    subnode = node.firstChild()
    while subnode.isNull() is False :
            name = subnode.nodeName()
            dom_element = subnode.toElement()
            
            if dom_element.isNull() :
                treeWidgetItem = QTreeWidgetItem()
                treeWidgetItem.setText(0, subnode.nodeValue())
                icon = getThemeIcon("property.png")
                treeWidgetItem.setWhatsThis(0, "property")
                treeWidgetItem.setIcon(0, QIcon(icon))                
                parentTreeWidgetItem.addChild(treeWidgetItem)
                dataDict[nameNode] = subnode.nodeValue()
            else :
                if dom_element.hasChildNodes():
                    treeWidgetItem = QTreeWidgetItem()
                    treeWidgetItem.setText(0, subnode.nodeName())
                    icon = getThemeIcon("join.png")
                    treeWidgetItem.setWhatsThis(0, "node")
                    treeWidgetItem.setIcon(0, QIcon(icon))                    
                    parentTreeWidgetItem.addChild(treeWidgetItem)

                    nameNode+= "/%s" % name; dataDict = introspectNodeXml(dataDict, subnode, nameNode, treeWidgetItem)
            subnode = subnode.nextSibling()
    return dataDict  

def getDicoXml(content):
    
        treeWidget = QTreeWidget()
        treeWidget.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        treeWidget.setObjectName("treeWidget")
        treeWidget.headerItem().setText(0, "1")
        treeWidget.header().setVisible(False)
        treeWidget.header().setDefaultSectionSize(200)
        
        domDocument = QDomDocument()
        domDocument.setContent(content)
        dataDict = {}
        dom_element = domDocument.documentElement()
        node = dom_element.firstChild()
      
        while node.isNull() is False :
            name = node.nodeName()

            attributes = ""
            if node.hasAttributes(): attributes = getAttributes(node)
            
            treeWidgetItem = QTreeWidgetItem()
            treeWidgetItem.setText(0, node.nodeName())
            icon = getThemeIcon("qsr.png")
            treeWidgetItem.setWhatsThis(0, "node")

            treeWidgetItem.setToolTip(0, attributes)
            
            treeWidgetItem.setIcon(0, QIcon(icon))
            treeWidget.addTopLevelItem(treeWidgetItem)
            
            dom_element = node.toElement()
            if dom_element.isNull() : dataDict[name] = dom_element.text()
            else :
                if dom_element.hasChildNodes(): dataDict = introspectNodeXml(dataDict, node, node.nodeName(), treeWidgetItem) 
            node = node.nextSibling() 
        return treeWidget
    

def getAttributes(node):
    attributes = ""
    try :
        for i in range(node.attributes().length()):
            attributeItem = node.attributes().item(i)
            attribute = attributeItem.toAttr()
            attributes+= ' %s="%s"' % (attribute.name(), attribute.value())
    except : pass
    return attributes    

def introspectNode(dataDict, node, nameNode):
    subnode = node.firstChild()
    while subnode.isNull() is False :
            name = subnode.nodeName()
            dom_element = subnode.toElement()
            if dom_element.isNull() : dataDict[nameNode] = subnode.nodeValue()
            else :
                if dom_element.hasChildNodes(): nameNode+= "/%s" % name; dataDict = introspectNode(dataDict, subnode, nameNode)
            subnode = subnode.nextSibling()
    return dataDict

def colorizeWords(content):
        domDocument = QDomDocument()
        domDocument.setContent(content)
        dataDict = {}
        dom_element = domDocument.documentElement()
        node = dom_element.firstChild()
        while node.isNull() is False :
            name = node.nodeName()
            dom_element = node.toElement()
            if dom_element.isNull() : dataDict[name] = dom_element.text()
            else :
                if dom_element.hasChildNodes(): dataDict = introspectNode(dataDict, node, node.nodeName()) 
            node = node.nextSibling() 
        content = "<table border=1>"
        for key, value in dataDict.items() :
            content+= "<tr valign='top'><td><b><u><font color=blue>%s</font></b></u></td><td>%s</td></tr>" % (textwrapfill(key,50), value)
        content+= "</table>"
        return content


def testXmlData(obj, fileName, fromWeb):
        dataXml = QDomDocument()
        
        try :
            content = open(fileName, "r")
            try : dataXml.setContent(content.read())
            except : return None, None
            content.close()
        except : dataXml.setContent(fileName)
  
        try : root = dataXml.documentElement()
        except : tree, root = None, None

        if root == None :
            title = QApplication.translate("QSphere","Information")
            msg = QApplication.translate("QSphere","Error on unsupported content :")  if not fromWeb else QApplication.translate("QSphere","Error on download stream ")
            sendMsg(obj, title , "%s :\n%s" % (msg, fileName), Qgis.Info, obj.duration_info)
            return False, None

        if not root.attribute("xmlns:gmd") == 'http://www.isotc211.org/2005/gmd': 
           msg = QApplication.translate("QSphere","XML document does not appear to be ISO (not gmd:MD_Metadata found) !")
           sendMsg(obj, "information" , msg, Qgis.Warning, obj.duration_warning) 
           return False, None

        if not fromWeb :    
            from qsphere.xmlisoparser import xmlIsoParser
            
            isoParser = xmlIsoParser(fileName, None, 'MEDDE', obj.localLangage)
            cond = isoParser.getTagDictionnary()
            if not cond :
               msg = "%s<br>%s" % (QApplication.translate("QSphere","XML dictionnary file for QSphere !"),
                                   QApplication.translate("QSphere","Open or add this file with the dictionnary interface (list of contacts) !"))
               sendMsg(obj, "information" , msg, Qgis.Warning, obj.duration_warning) 
               return False, None
        

        if not fromWeb : return True, None
        else : return True, dataXml.toString()


#================================================
# FUNCTIONS DATE 
#================================================
def bissextile(an):
    if (an % 4)==0:
        if (an % 100)==0 and (an % 400) != 0 : return False
        else : return True
    else:
        return False
 
def verifdate(j,m,a):
    if a<100:
        if a<0: return False  
        if a<50: a += 2000  
        else: a += 1900  
    if m<1 or m>12 or j<1: return False
    if j>(31,29,31,30,31,30,31,31,30,31,30,31)[m-1]: return False
    if (not bissextile(a)) and m==2 and j>28: return False
    return True
 
def verifdatechaine(d, sep="/"):
    l = d.split(sep)
    if len(l) != 3: return False
    try: a, m, j = int(l[0]), int(l[1]), int(l[2])
    except: return False
    return verifdate(j, m, a)

#================================================
# LIST OF DATASOURCES
#================================================
"""
def getOdbcSources():
    sources = pyodbcdataSources()
    dsns = sources.keys()
    dsns.sort()
    listODBCSources = []
    for dsn in dsns : listODBCSources.append("%s [%s]" % (dsn, sources[dsn]))
    return listODBCSources
"""
def qgisPortDataSources():
    ports = []
    ports = getInfosFromSettings( ports, "port", "/PostgreSQL/connections")
    ports = getInfosFromSettings( ports, "port", "/ODBC/connections")
    return ports

def qgisKeyDataSources():
    keys = []
    keys = getSettingsInfos( keys, "/PostgreSQL/connections")
    keys = getSettingsInfos( keys, "/ODBC/connections")
    return keys


def getEpsg(text):
    idEpsg = "-1" 
    if text.find("EPSG:")!=-1:
       position = text.find("EPSG:")
       idEpsg = text[position+5:position+11].replace(":", "")
       while not isIntNumber("%s" % idEpsg):
             idEpsg = idEpsg[:-1]
             if idEpsg == "" :
                idEpsg = "-1"
                break  
    return idEpsg

def getInfosFromSettings(listInfos, keySettings, groupSettings):
    settings = QSettings()
    settings.beginGroup(groupSettings)
    keys = settings.childGroups()
    if keys != []:
       for key in keys :
           mySettingsKey = QSettings()
           elt = mySettingsKey.value("%s/%s/%s" % (groupSettings, key, keySettings))
           if not elt in listInfos : listInfos.append(elt)
    return listInfos

def getSettingsInfos(listInfos, groupSettings):
    settings = QSettings()
    settings.beginGroup(groupSettings)
    keys = settings.childGroups()
    if keys != []:
       for elt in keys :
            if not elt in listInfos : listInfos.append(elt)
    return listInfos

def getParamsConnexionQGIS(connexionKey):
    settings = QSettings()
    settings.beginGroup("/PostgreSQL/connections")
    keys = settings.childGroups()
    listInfos = []
    if keys != []:
       for key in keys :
           if key == connexionKey :
               mySettingsKey = QSettings()
               listInfos.append(mySettingsKey.value("/PostgreSQL/connections/%s/host" % (key)) )
               listInfos.append(mySettingsKey.value("/PostgreSQL/connections/%s/port" % (key)))
               listInfos.append(mySettingsKey.value("/PostgreSQL/connections/%s/username" % (key)))
               listInfos.append(mySettingsKey.value("/PostgreSQL/connections/%s/password" % (key)))
               listInfos.append(mySettingsKey.value("/PostgreSQL/connections/%s/database" % (key)))
               break
    return listInfos
           
def qgisDataSourcesPorts():
    sources = QgsProviderRegistry.instance().databaseDrivers()
    dsns = sources.split(";")
    ports = sl = []
    for dsn in dsns :
         ports = getInfosFromSettings( ports, "port", "/%s/connections" % (dsn.split(",")[0]))
    return ports

def getIp(serverName):
    import socket
    return (socket.gethostbyname_ex(serverName))

def getOpenPort():
    import socket
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_IP) #socket.SOCK_RAW) #, socket.IPPROTO_IP)
    s.bind(("",0))
    port = s.getsockname()#[1]
    s.close()
    return port
    
def qgisDirectorySources(self):
    sources = QgsProviderRegistry.instance().directoryDrivers()
    dsns = sources.split(";")
    qgisDirectorySources = []
    for dsn in dsns : qgisDirectorySources.append("%s" % (dsn))
    return qgisDirectorySources

#================================================
# LIST OF DATASOURCES - END
#================================================
def getListLayers(self, targetList, model, comboBox, onlyVector):
   root = QgsProject.instance().layerTreeRoot()
   targetList.clear()
   comboBox.clear()
   defaultValue = QApplication.translate("QSphere","No layer")

   item = QStandardItem(defaultValue)
   item.setData("0", Qt.UserRole)
   model.appendRow(item) 
   
   targetList[0], maxDim = [], len(defaultValue)
   i = 0
   if root != None :
       for layer in root.findLayers() : 
           if not (type(layer.layer()) == QgsRasterLayer and onlyVector) : 
              if not dicoHasKey(targetList, layer.layerId()): dim = addItemInModel(self, targetList, model, layer)
           maxDim = max(maxDim, dim)
   comboBox.setModelColumn(0)
   comboBox.show()
   comboBox.setCurrentIndex(-1)
   return maxDim

def addItemInModel(self, targetList, model, layer):
   item = QStandardItem(layer.name())
   item.setData("%s" % layer.layerId(), Qt.UserRole)
   model.appendRow(item) 
   targetList[layer.layerId()] = []
   return len(layer.name())


def getComboLayer(self, comboBox, inLegend):
   targetLayer = None
   if comboBox.currentIndex() != -1 :
       modelIndex = comboBox.model().index(comboBox.currentIndex(),0)
       layerId = comboBox.model().data(modelIndex, Qt.UserRole)
       root = QgsProject.instance().layerTreeRoot()
       if root != None :
               for layer in root.findLayers() :
                   if layer.layerId() == layerId: targetLayer = layer.layer(); break;
   return targetLayer


def getComboLayerIndex(self, comboBox, text):
   model, index = comboBox.model(), 0
   for i in range(comboBox.count()):
       if model.item(i).text() == text :    
          index = i  
          break
   return index


def getLayerById(self, layerId):
   layer = None
   layers = self.iface.mapCanvas().layerCount()
   for i in range(0, layers):
       layer = self.iface.mapCanvas().layer(i)
       if layer.id() == layerId: break
   return layer

def getKeyInDicoFromValue(collection, valueSearch):
    root = collection.invisibleRootItem()
    for i in range(root.childCount()):
        item = root.child(i)
        if item.whatsThis(0) == valueSearch : return item
    return None

def fixeClassObj(libClassObj, nameObj, window):
    obj = None    
    if libClassObj in ("QTableWidget", "MyTableWidget", "myTableWidget") :  obj = window.findChild(myTableWidget, nameObj)
    elif libClassObj == "QTableView" : obj = window.findChild(QTableView, nameObj)
    elif libClassObj in ("QCalendarWidget", "QgsDateTimeEdit") : obj = window.findChild(QgsDateTimeEdit, nameObj)
    elif libClassObj in ("QTextEdit", "MyTextEdit", "myTextEdit") :
         obj = window.findChild(myTextEdit, nameObj)
         if obj == None : obj = window.findChild(QTextEdit, nameObj)
    elif libClassObj in ("QLineEdit", "MySimpleWidgetLineEdit", "MyWidgetLineEdit") :
         obj = window.findChild(MyWidgetLineEdit, nameObj)
         if obj == None :
            obj = window.findChild(MySimpleWidgetLineEdit, nameObj)
            if obj == None :
               obj = window.findChild(QLineEdit, nameObj)
    elif libClassObj in ("QComboBox", "MyComboBox", "myComboBox") :        
         obj = window.findChild(myComboBox, nameObj)
         if obj == None :
            obj = window.findChild(QComboBox, nameObj)
    elif libClassObj == "QGroupBox" : obj = window.findChild(QGroupBox, nameObj)
    elif libClassObj == "QRadioButton" : obj = window.findChild(QRadioButton, nameObj)
    return obj        


def isMailUrl(url):
    url = url.strip().replace("mailto:", "")
    regex = QRegExp(r"(^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,6}$)", Qt.CaseSensitive)
    return regex.exactMatch(url)

def getListWmsServer():
    from os.path import (basename, dirname, splitext)
    listeWmsServer = []
    path = correctPath(dirname(__file__))
    path = "%s/xml/geoloc" % (path)
    for dirname, dirnames, filenames in walk(path):
        for fileName in filenames:
            name = "%s" % (basename(fileName))
            extension = getExtension(fileName)
            if extension != "" and extension == ".xml": listeWmsServer.append(name)
    return listeWmsServer

def getListXslt(self):
    from os.path import (basename, dirname, splitext)
    listXslt = []
    path = correctPath(dirname(__file__))
    path = "%s/xml/xsl" % (path)
    for dirname, dirnames, filenames in walk(path):
        for fileName in filenames:
            name = "%s" % (basename(fileName))
            extension = getExtension(fileName)
            if extension != "" and extension == ".xsl": listXslt.append(name)
    return listXslt

def textForMenu(pattern, text, maxDim, shorcuts): return pattern % (text.ljust(maxDim-len(text)), shorcuts)

def cleanHtml(html):
    if html != None :
        html = html.replace('&amp;', '&')
        html = html.replace('&gt;', '>')
        html = html.replace('&lt;', '<')
    return html

def netToHtml(html):
    if html != None :
        html = html.replace('&', '&amp;')
        html = html.replace('>', '&gt;')
        html = html.replace('<', '&lt;')
    return html

def dicoHasKey(dico, key):
    cond = False
    try : cond = dico.has_key(key)
    except : cond = (key in dico)
    return cond

def fixeRanges(records):
    if records <= 50 : plages = 1
    elif records > 50 and records <= 500 : plages = 2
    elif records > 500 and records <= 1000 : plages = 4
    elif records > 1000 and records <= 5000 : plages = 6
    elif records > 5000 and records <= 10000 : plages = 8
    else : plages = 10
    return nplinspace(0, records, plages)

def convertSize(size):
   size_name = ("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB")
   i = 0
   if size > 0 :
      i = int(floor(log(size,1024)))
      p = pow(1024,i)
      s = round(size/p,2)
   else :
      s = 0
   return '%s %s' % (s,size_name[i])

def prettifyXml(xml):
    return parseString(xml).toprettyxml()


def getSelConnexion(self):
  settings = QSettings()
  value = settings.value("/qsphere/connections/selected")
  return value

def isoNameSpaces(key):
    obj = Namespaces()
    return obj.get_namespace(key)

def appendNameSpace(self, path):
    nameSpaceAppendedPath = ''
    pathElements = path.split('/')
    count = 0
    for element in pathElements:
            try:					
                    if ':' in element:						
                            splitElement = element.split(':')
                            nsPrefix, nsElement = splitElement[0], splitElement[1]
                    else:
                            nsPrefix = self.defaultIsoNamespace()
                            nsElement = element
                    if count == 0: appendedPath = '{%s}%s' % (isoNameSpaces(nsPrefix) , nsElement)
                    else: appendedPath = '%s/{%s}%s' % (appendedPath , isoNameSpaces(nsPrefix) , nsElement)
                    count += 1
            except:	appendedPath = 'null'
    nameSpaceAppendedPath = appendedPath.replace('{}','')
    return nameSpaceAppendedPath

def multiGetRequest(anim, ctrlanim, uris, timeout, useCase): 
    def alive_count(lst, i):
        print()
        try : anim.jumpToFrame(i)
        except : pass
        ctrlanim.repaint()
        alive = map(lambda x : 1 if x.isAlive() else 0, lst)
        return reduce(lambda a,b : a + b, alive)

    if useCase == 0 : threads = [ urlThread(uri[0], uri[1], uri[2], uri[3]) for uri in uris ]
    elif useCase == 1 : threads = [ urlThreadRequests(uri[0]) for uri in uris ]
    elif useCase == 2 : threads = [ urlThreadSql(uri[0], uri[1]) for uri in uris ]
    
    for thread in threads:
        thread.start()
        i = 0
    while alive_count(threads, i) > 0 and timeout > 0.0:
        try :
            i = i+1 if i < (anim.frameCount()-1) else 0
        except : ctrlanim.repaint()     
        timeout = timeout - UPDATE_INTERVAL
        sleep(UPDATE_INTERVAL)
    return [ (x.url, x.response) for x in threads ]

class urlThread(Thread):
    def __init__(self, url, method, headers, data=None):
        super(urlThread, self).__init__()
        self.response = None
        self.timeOut = False
        self.url = url
        self.method = method
        self.headers = headers
        self.data = data.encode("utf-8")
        self.ftpMode = url.startswith('ftp://')

    def run(self):
        if self.ftpMode :
            try:
                self.response = urllib.urlopen(url)
            except IOError as e: self.response, reason = None, e
            else:
                if self.response.read(): self.response, reason = self.response.status_code, self.response.reason
                else: self.response, reason = None, 'Empty Page'
        else :    
            try:
                self.response = requests.get(self.url, timeout=6, auth=None, headers=self.headers)
            except (requests.ConnectionError, requests.HTTPError, requests.Timeout) as e: self.response, reason = None, e
            else:
                if self.response.text: self.response, reason = self.response.status_code, self.response.reason
                else: self.response, reason = None, 'Empty Page'
            

class urlThreadRequests(Thread):
    def __init__(self, url):
        super(urlThreadRequests, self).__init__()
        self.response = None
        self.timeOut = False
        self.url = url

    def run(self):
        hdr = {'User-Agent': 'OpenAnything/1.0 +http://somepage.org/', 'Connection': 'keep-alive'}
        try : 
            request = Request(self.url, headers=hdr)
            opener = build_opener()  
            self.response = opener.open(request).read()
        except : self.response = None
        
#TEST
class urlThreadSql(Thread):
    def __init__(self, url, cursor):
        super(urlThreadSql, self).__init__()
        self.response = None
        self.timeOut = False
        self.cursor = cursor
        self.url = url

    def run(self):
        records = None
        try :
            self.cursor.execute(self.url)
            #self.response = self.cursor.fetchall()
            return 1
        except psycopg2.Error as e:
            if e.pgcode == None and e.pgerror == None : return 0
            else : return None

        
#TEST
#================================================
# FUNCTION TO FORCE / VERIFY EXTENSION
#================================================
def fileNameWithExtension(self, fileName, selectedFilter):
    extension = ""
    file = QFileInfo(fileName)
    extensionfind = ".%s" % (file.suffix())

    if selectedFilter.find("(")!=-1 :
        s = selectedFilter.find("*")+1
        e = selectedFilter.find(" ", s)
        e2 = selectedFilter.find(")", s)
        if (e == -1 and e2 < e) : e = e2 
        extension = selectedFilter[s:e].replace("*","")
    else :
        if selectedFilter.find("*.")!=-1 : extension = selectedFilter.replace("*","")
        
    if(file.suffix()=="") or (extensionfind.find(extension)==-1) : fileName+= "%s" % (extension)

    return fileName

#================================================
# FUNCTIONS TO RESTORE SIZE COLUMNS QTABLEWIDGET
#================================================
def initSizeCols(self, obj, dims):
    if type(dims) == int : obj.setColumnWidth(0, dims)
    else :
        for i in range(len(dims)): obj.setColumnWidth(i, dims[i])

def changeSizeCols(self, obj, dims, prorata):
    if type(dims) == int : obj.setColumnWidth(0, int(dims * prorata))
    else :
        for i in range(len(dims)): obj.setColumnWidth(i, int(dims[i] * prorata)-10 )  

def getOptions(self):
    self.serverMetadata, self.serverKeywords, self.serverNavigator, self.serverLustre, self.InitDir, self.showWarning, self.duration_info, self.duration_warning, self.duration_timeout, \
    self.autoCorrect, self.byStream, self.byFile, self.InitDirByFile, self.silentMode, self.autoComment, self.reportingCSWT, self.startColor, self.stopColor  = loadOptions()

def loadOptions():
    serverMetadata = []
    serverKeywords = []
    serverNavigator = []
    serverLustre = ""
    initFolder = dirname(__file__)
    initFolderByFile = dirname(__file__)
    duration_info = duration_warning = duration_timeout = 5
    autoCorrect = byStream = byFile = silentMode = showWarning = reportingCswt = autoComment = False
    startColor = stopColor = ""

    savefile = join(dirname(__file__),"ressources/options.ini")
    if exists(savefile):

         config = ConfigParser()
         config.read(savefile)
         sections = config.sections()

         for section in sections :
             if section == "serverMetadata" :
                items = int(config.get(section,'items').rstrip())
                for k in range(items): serverMetadata.append(config.get(section,'item_%s' % (k)))
             elif section == "serverKeywords" :
                items = int(config.get(section,'items').rstrip())
                for k in range(items): serverKeywords.append(config.get(section,'item_%s' % (k)))
                try :
                     index = int(config.get(section,'index').rstrip())
                     serverLustre = config.get(section,'item_%s' % index)
                except : serverLustre = "http://linkeddata.ge.imati.cnr.it/"
             elif section == "serverNavigator" :
                 items = int(config.get(section,'items').rstrip())
                 for k in range(items): serverNavigator.append(config.get(section,'item_%s' % (k)))
             elif section == "folder" :
                 initFolder = config.get(section,'initFolder')
                 if initFolder == "" or not (exists(initFolder)) : initFolder = dirname(__file__)
             elif section == "checkShowWarning" :
                 try : showWarning = literal_eval(config.get(section,'state'))
                 except : pass                 
             elif section == "sliderInformation" :
                 try : duration_info = int(config.get(section,'value'))
                 except : pass
             elif section == "sliderWarning" :
                 try : duration_warning = int(config.get(section,'value'))
                 except : pass
             elif section == "sliderTimeOut" :
                 try : duration_timeout = int(config.get(section,'value'))
                 except : pass
             elif section == "checkAutoCorrect" :
                 try : autoCorrect = literal_eval(config.get(section,'state'))
                 except : pass
             elif section == "radioStream" :
                 try : byStream = literal_eval(config.get(section,'state'))
                 except : pass                 
             elif section == "radioFile" :
                 try : byFile = literal_eval(config.get(section,'state'))
                 except : pass
             elif section == "folderXml" :
                 initFolderByFile = config.get(section,'initFolder')
                 if initFolderByFile == "" or not (exists(initFolderByFile)) : initFolderByFile = dirname(__file__) 
             elif section == "checkSilentMode" :   
                 try : silentMode = literal_eval(config.get(section,'state'))
                 except : pass
             elif section == "checkAutoComment" :   
                 try : autoComment = literal_eval(config.get(section,'state'))
                 except : pass  
             elif section == "checkReportingCswt" :   
                 try : reportingCswt = literal_eval(config.get(section,'state'))
                 except : pass
             elif section == "startColor" :
                 try : startColor = config.get(section,'name')
                 except : pass
             elif section == "stopColor" :    
                 try : stopColor = config.get(section,'name')
                 except : pass
                 
    return serverMetadata, serverKeywords, serverNavigator, serverLustre, initFolder, showWarning, duration_info, duration_warning, duration_timeout, \
    autoCorrect, byStream, byFile, initFolderByFile, silentMode, autoComment, reportingCswt, startColor, stopColor


def getExtension(fileName):
    from os.path import (basename, splitext)
    textension = splitext(fileName)
    extension = textension[len(textension)-1].lower()
    return extension

def getEncodingCar(inputFile, xmlData):
    encoding = "utf8"
    if inputFile!= "" and xmlData == None:
       if  exists(inputFile):
           with open(inputFile, 'r', encoding="utf-8", errors="surrogateescape") as inFile : text = inFile.read()
    else :
        if xmlData != None :
            if type(xmlData) == str : text = xmlData
            else : text = xmlData.decode("utf-8", "ignore")
        else : return encoding    
    startPosition = endPosition = 0     
    startPosition = text.find("encoding=\"")
    if startPosition > 0 :
       endPosition = text.lower().find("\"", startPosition+10)
       if endPosition > startPosition :  encoding = text[startPosition+10:endPosition].lower().replace("-","")
    return encoding 


def changeButtonIcon(self, button, icon, iconWidth, iconHeight):
    icon = getThemeIcon(icon)
    button.setIcon(QIcon(icon))

#============================
# FUNCTIONS SEARCH WEB FILES
#============================
def getFilesInFolder(self, path, vectorLayer, counter, allPath, extension):
    i, countfiles, position = 0, 0, 0
    folders = {}

    font = QFont()
    font.setPointSize(8) 
    font.setWeight(10) 
    font.setBold(True)

    Qicondir = QIcon(getThemeIcon("open.png"))
    menuIcon = getThemeIcon("mime/file/%s.png" % (extension))
    if menuIcon == "" : menuIcon = getThemeIcon("mime/file/unknow.png")
    QmenuIcon = QIcon(menuIcon)
    position = 0
    
    for folderdirname, folderdirnames, filenames in walk(path):
        for filename in filenames: i, folders, countfiles, position  = scanFolder(self, path, folderdirname, join(folderdirname, filename), vectorLayer, counter, i, folders, font, Qicondir, QmenuIcon, allPath, countfiles, position)

    return countfiles, len(folders)+1, folders


def scanFolder(self, path, folderdirname, currentFile, vectorLayer, counter, i, folders, fontDirs, Qicondir, QmenuIcon, allPath, countfiles, position):
        if isfile(currentFile):
            extension = getExtension(currentFile)

            anaFile = currentFile if allPath else basename(currentFile)
          
            if self.filter.exactMatch(anaFile) :
                inputFile = QFileInfo(currentFile)

                feature = QgsFeature(vectorLayer.fields()) #pendingFields())
                feature.setAttributes([currentFile, 
                                       inputFile.size(),
                                       formatedSize(inputFile.size()),
                                       inputFile.created().toString('yyyy-MM-dd hh:mm:ss'),
                                       inputFile.lastModified().toString('yyyy-MM-dd hh:mm:ss'),
                                       inputFile.lastRead().toString('yyyy-MM-dd hh:mm:ss')
                                       ]) 

                target = folderdirname.replace(path, "").replace("\\", "/")
                vectorLayer.dataProvider().addFeatures([feature])

                if target != "" and not dicoHasKey(folders, target): folders[target] = [0, 0]

                countfiles+= 1

                if target != "" :
                    folders[target][0] = folders[target][0]+ 1
                    folders[target][1] = folders[target][0]+ inputFile.size() 
                
                self.refreshCounter(countfiles, len(folders))
                
            i = i+1 if i < (counter-1) else 0
            self.movieCtrl.movie.jumpToFrame(i)
            self.movieCtrl.repaint()
                
        return i, folders, countfiles, position


#=================================
# FUNCTIONS FIXE VALUE AND WIDGET
#=================================
def getIndex(obj):
    try : index = int(obj.toolTip())
    except : index = -1
    if index == -1 : index = 0
    return index

def toolTipCalendar(self, calendar):
    theDate = dateToString(self, calendar)
    msg = "%s%s" % (QApplication.translate("QSphere","Present Value : "), theDate )
    calendar.setToolTip(msg)
    return msg

def getTypeLayer(self, layerType):
    index = int(layerType)
    types = ("vector", "raster", "plugin")
    return types[index]

def setTextWidget(self, targetWidget, text, isValue):
    obj = getWidget(self, targetWidget)     
    if obj :
       obj.setText(text) if not isValue else obj.setValue(float(text))

def getTextWidget(self, targetWidget, isValue):
    obj = getWidget(self, targetWidget)
    info, text = "", ""
    if obj == None : return info, text
    
    objClassName = "%s" % (obj.metaObject().className())
    if objClassName in ("QLineEdit", "MyWidgetLineEdit"):    
        info = "%s" % (netToHtml(obj.text()))
        text = "%s" % (netToHtml(obj.text()))
    elif objClassName in ("QCalendarWidget", "QgsDateTimeEdit") :
        info = dateToString(self, obj)
        text = info        
    elif objClassName in ("QComboBox", "MyComboBox", "myComboBox") :
        info = "%s" % (obj.currentText())
        info = info.lower()
        text = "%s" % (obj.currentText())
    elif objClassName in ("QTextEdit", "MyTextEdit", "myTextEdit") :
        info = "%s" % (netToHtml(obj.toPlainText()))
        text = info
    return info, text

def getWidget(self, targetWidget):
    obj = None
    if self.objectName() in ("dlgMetadata", "dlgOptions") :    
        for mddcollapsibleGroupBox in self.mddcollapsibleGroupBox:
             if mddcollapsibleGroupBox :
                widgets = mddcollapsibleGroupBox.children()
                for j in range(len(widgets)):
                    if widgets[j].objectName() == targetWidget :
                       obj = widgets[j]
                       return obj
                    elif type(widgets[j]) == QGroupBox :
                         for subchild in widgets[j].children() :
                             name = ""
                             name = subchild.objectName()
                             if name == targetWidget : return subchild   
    else:
       
        for child in self.children() :
          if type(child) == QGroupBox :
             for subchild in child.children() :
                 name = ""
                 name = subchild.objectName()
                 if name == targetWidget : return subchild
          else :
             name = ""
             name = child.objectName()
             if name == targetWidget : return child
    
    return obj


#==========================
# FUNCTIONS BUILDING LISTS
#==========================
def getListCountries(self):
    listCountries, listCountriesCode, indexCountry, targetLang = [], {}, 0, ""
    isHd = False
    zipReg = {"UnitedStates" : ("^\d{5}([\-]?\d{4})?$","99999-9999;X"),
              "United States" : ("^\d{5}([\-]?\d{4})?$","99999-9999;X"),
              "UnitedKingdom"  : ("^[A-Z]{1,2}[0-9]{1,2}[A-Z]?\s[0-9][A-Z][A-Z]$","XXXXXXXX;X"),
              "United Kingdom"  : ("^[A-Z]{1,2}[0-9]{1,2}[A-Z]?\s[0-9][A-Z][A-Z]$","XXXXXXXX;X"),
              "Germany" : ("^(\d{5}$)", "99999;X"),
              "Canada" : ("(^+[A-VXY][0-9][A-Z] +[0-9][A-Z][0-9]$)", "XXX XXX;X"),
              "France" : ("(^(([0-8][0-9])|(9[0-5]))[0-9]{3}$)","99999;X"),
              "Italy" : ("^(\d{5})$", "99999;X"),
              "Italia" : ("^(\d{5}$)", "99999;X"),
              "Australia" : ("^(\d{3})$", "999;X"),
              "Netherlands" : ("^[0-9]{4} [A-Z]{2}", "9999XX;X"),
              "Spain" : ("^(\d{5}$)", "99999;X"),
              "Denmark" : ("^([D-d][K-k])?( |-)?[1-9]{1}[0-9]{3}$","X999;X"),
              "Sweden" : ("^(\d{3} \d{2})$","999 99;X"),
              "Belgium" : ("^[1-9]{1}[0-9]{3}$","9999;X"),
              "India" : ("^\d{6}$","999999;X")
              } 

    if QT_VERSION <= 263937 :
        isHd = False    
        langlocale = self.localeFullName
    else :
        isHd = True
        langlocale = []
        langLocaleFullName = self.localeFullName
        if langLocaleFullName.find("-")==-1: langLocaleFullName = langLocaleFullName.replace("-","_")
        if langLocaleFullName.find("_")==-1: langLocaleFullName+= "_%s" % (langLocaleFullName.upper())
        langlocale.append("%s" % (langLocaleFullName)) 

  
    for langId in range(QLocale.C, QLocale.LastLanguage + 1):
        lang = QLocale.Language(langId)
        countries = QLocale.matchingLocales(lang, QLocale.AnyScript, QLocale.AnyCountry) 
        for country in countries:
            locale = QLocale(lang, QLocale.AnyScript, QLocale.AnyCountry) 
            
            if isHd : label = locale.nativeCountryName()    
            else : label = "%s" % (QLocale.countryToString(country))
            
            if (label not in listCountries and not label in ("", "Default")) :

               if langlocale == locale.name(): targetLang = label
               if type(langlocale)== list :
                   if locale.name() in langlocale : targetLang = label
               else :
                   if langlocale == locale.name(): targetLang = label
               try :
                    listCountries.append(label)
                    if dicoHasKey(zipReg, label):    
                       listCountriesCode[label] = zipReg[label] 
                    else :  listCountriesCode[label] = ("(^+[a-zA-Z_0-9\s]{3,10}$)","XXXxxxxxxx;X")  
               except : pass                     
    listCountries.sort()
    
    if targetLang != "" and targetLang in listCountries : indexCountry = listCountries.index(targetLang)
    return listCountries, indexCountry, listCountriesCode    


def getListTypeRessources(self): return ("attribute", "attributeType", "collectionHardware", "collectionSession",
                                         "dataset", "dimensionGroup", "feature", "featureType", "fieldSession", "model",
                                         "nonGeographicDataset", "propertyType", "series", "service", "software", "tile") 

def getListTemporalSystem(self):
    temporalSystem = (QApplication.translate("QSphere","Ethiopian"),
                           QApplication.translate("QSphere","Gregorian"),
                           QApplication.translate("QSphere","Hegirian"),
                           QApplication.translate("QSphere","Persan"),
                           QApplication.translate("QSphere","Vikram Samvat")
                  )    
    return temporalSystem
    

def getListEncoders(self):
    fileEncoders = join(dirname(__file__),"ressources/gmxcodelists.xml")
    listEncoders = []
    if exists(fileEncoders):
       listEncoders = gmlListEncoders(self, fileEncoders)
    if listEncoders == [] :
       from encodings.aliases import aliases
       listEncoders = sorted(aliases.keys())
    return listEncoders   

def gmlListEncoders(self, fileEncoders):
    listEncoders = []
    from xml.etree import ElementTree as ET
    try : etree = ET.parse(fileEncoders)
    except : return []
    root = etree.getroot()
    if root == None : return []

    start = False 
    for elt in root.iter():
        if start == True :
           if elt.tag == "{http://www.opengis.net/gml/3.2}identifier" and elt.text.find('MD_ClassificationCode')== -1: listEncoders.append(elt.text)
        if elt.text.find('MD_CharacterSetCode')!= -1 : start = True
        elif elt.text.find('MD_ClassificationCode')!= -1 : break
    return sorted(listEncoders)

def getRandowId(self):
    pop = ascii_letters + digits
    #k=12
    generateId = ''.join( sample(pop, 12) )
    today = datetime.now() 
    generateId+= today.strftime("_%m%d%HH%MM%SS")
    return generateId

def getIsoCodes(pathData):
    pathData = "%s/ressources/%s" % (dirname(__file__).replace("\\","/"), pathData)
    isoCodes = {}
    if exists(pathData) :
        inputFile = codecsopen(pathData, 'rb', 'utf-8')
        for line in inputFile:
            ids = {}
            ids['bibliographic'], ids['terminologic'], ids['alpha2'], ids['english'], ids['french'] = line.strip().split('|')
            isoCodes[ids['bibliographic']] = ids
            if ids['terminologic']:  isoCodes[ids['terminologic']] = ids
            if ids['alpha2']: isoCodes[ids['alpha2']] = ids
            for k in ids: ids[k] = ids[k] or None
        inputFile.close()
    return isoCodes

def makeListFormatsExtensions(self, vector, raster):
    listFormatsExtensions, listFormatsExtensionsVector, listFormatsExtensionsAll = [], [], []

    for iDriver in range(ogr_GetDriverCount()):
        poDriver = ogr_GetDriver(iDriver)
        poValue = poDriver.GetName()
        driver = gdal_GetDriverByName("%s" % (poValue))
        listFormatsExtensionsVector = setEltListFormatsExtensions(self, listFormatsExtensionsVector, driver, poValue)
        

    for iDriver in range(gdal_GetDriverCount()):
        poDriver = gdal_GetDriver(iDriver)
        poValue = poDriver.ShortName
        driver = gdal_GetDriverByName("%s" % (poValue))
        listFormatsExtensionsAll = setEltListFormatsExtensions(self, listFormatsExtensionsAll, driver, poValue)

    if vector and raster : listFormatsExtensions =  listFormatsExtensionsAll
    else :
        if vector : listFormatsExtensions = listFormatsExtensionsVector
        elif raster : listFormatsExtensions = [value for value in listFormatsExtensionsAll if value not in listFormatsExtensionsVector] 

    listFormatsExtensions.append('*')
    return sorted(listFormatsExtensions)

def setEltListFormatsExtensions(self, listFormatsExtensions, driver, poValue):
       if driver :
            poDriverMetadata = driver.GetMetadata()
            if dicoHasKey(poDriverMetadata, DMD_EXTENSION):
                if poDriverMetadata[DMD_EXTENSION]!= '' and not poDriverMetadata[DMD_EXTENSION] in  listFormatsExtensions : listFormatsExtensions.append(poDriverMetadata[DMD_EXTENSION])
       else :
           if poValue != '' and not poValue in  listFormatsExtensions : listFormatsExtensions.append[poValue]
       return listFormatsExtensions

def getListFormats(self):
    listFormats = {}
    for iDriver in range(ogr_GetDriverCount()):
        poDriver = ogr_GetDriver(iDriver)
        poValue = poDriver.GetName()
        driver = gdal_GetDriverByName("%s" % (poValue))
        listFormats = setEltListFormats(self, listFormats, driver, poValue)

    for iDriver in range(gdal_GetDriverCount()):
        poDriver = gdal_GetDriver(iDriver)
        poValue = poDriver.ShortName
        driver = gdal_GetDriverByName("%s" % (poValue))
        listFormats = setEltListFormats(self, listFormats, driver, poValue)

    listitems = sortDic(listFormats)

    return listitems

def setEltListFormats(self, listFormats, driver, poValue):
       if driver :
            poDriverMetadata = driver.GetMetadata()
            if dicoHasKey(poDriverMetadata, DMD_LONGNAME):    
               poFormat = poDriverMetadata[DMD_LONGNAME]
               listFormats[poFormat]=poFormat
            elif dicoHasKey(poDriverMetadata, DMD_MIMETYPE):    
               poFormat = poDriverMetadata[DMD_MIMETYPE]
               listFormats[poFormat]= poFormat
            elif dicoHasKey(poDriverMetadata, DMD_EXTENSION):    
               poFormat = poDriverMetadata[DMD_EXTENSION] 
               listFormats[poFormat]= poFormat
       else : listFormats[poValue]=poValue
       return listFormats


def getListLangs(self):
    languages = []
    langues = [QLocale(lang).language() for lang in languages]
    for language in range(QLocale.C, QLocale.Chewa + 1):
        if language not in (QLocale.C, QLocale.Chewa + 1):
           if languages and (language not in languages): continue
           langues.append( language )
    return langues

def getUiLangIndex(self):
    langue = QLocale().language()
    langueName = unicode( QLocale.languageToString( langue ))
    return langue, langueName

def getListLanguesIndex(self, obj, langue):
    keyLangues = sortDic(self.languesDico)
    i = iIndex = 0
    for keyLangue in keyLangues :
        if len(keyLangue)==3 :
           obj.addItem(self.languesDico[keyLangue]['bibliographic'])
           if self.languesDico[keyLangue]['english'] == langue : iIndex = i
           i+= 1
    return iIndex

def sortDic(dic):
    keys = dic.keys()
    try : keys.sort()
    except :
        try : keys = sorted(keys)
        except : pass
    return keys

def reloadTableView(self, config, obj, section, percentDeb, delta):
    infos = config.get(section,'Indexes')
    infos = infos.rstrip()
    itemInfos = config.get(section,'ItemCount')
    itemsCount = int(itemInfos.rstrip())
    diff =  obj.model().rowCount() - itemsCount
    percentDeb, delta = float(percentDeb), float(delta)

    if section == "tablelangues" :  iconData = "%s/ressources/images/" % (dirname(__file__).replace("\\","/"))
    
    if diff > 0 :
       while diff > 0 :
           obj.model().removeRow(obj.model().rowCount()-1)
           diff-= 1 
    
    for j in range(itemsCount):
        values = config.get(section,'Item_%s' % (j))

        self.progressBar.setValue(percentDeb + (float(j)/float(itemsCount))*delta)
        
        tabValues = None
        if values.find("|")!=-1: tabValues = values.split("|")
        colsCount = len(tabValues) if tabValues != None else 1 
        for l in range(colsCount):
           if section == "tablelangues" :
              icon = QIcon("%s%s%s" % (iconData, tabValues[0], ".png"))
              item = QStandardItem() if l == 0 else QStandardItem(icon, "")
           else : item = QStandardItem()
           item.setText("%s" % (unquote(tabValues[l]))) if tabValues != None else item.setText("%s" % unquote(values))
           if section == "groupedroits" : item.setToolTip(unquote(textwrapfill("%s" % (tabValues[colsCount-1]),50)))
           if l == 0 :
               item.setCheckState(Qt.Unchecked)
               item.setCheckable(True)
           item.setEditable(False)
           obj.model().setItem(j, l, item)

    if infos.find("|")!=-1 :
       dateInfos = infos.split("|")
       for j in range(len(dateInfos)): obj.model().item(int(dateInfos[j]), 0).setCheckState(Qt.Checked)
    else:
       if infos!="": obj.model().item(int(infos), 0).setCheckState(Qt.Checked)
       

def reloadTableWidget(self, config, obj, section):
    title = "Information"
    test, rows, cols = analyzeInfosObj(self, config, obj, section)
    maxCols = obj.columnCount()
    self.cleanAllObj(obj, False)
    if rows == 0 : return
   
    if test :
        if cols > maxCols :
            msg = QApplication.translate("QSphere","Columns number invalide for Object : ")
            sendMsg(self, title , "%s%s" % (msg, section), Qgis.Warning, self.duration_warning)
        else :
            test = True
            if obj.rowCount()>0 :
                for col in range(cols) :
                    infos = config.get(section,'zWidget_%s' % (col))
                    widgetClassInfos = infos.rstrip().split("|")
                    if obj.cellWidget(0, col)!= None :
                        widgetClassInfo = "%s" % (widgetClassInfos[0])
                        if widgetClassInfo != obj.cellWidget(0, col).metaObject().className():
                           if obj.cellWidget(0, col).metaObject().className() != "MySimpleWidgetLineEdit" :
                              test = False
                              break

            if not test :
               msg = QApplication.translate("QSphere","Sub-Widgets not support in the current version of QSphere for : " )
               sendMsg(self, title , "%s%s" % (msg, section), Qgis.Warning, self.duration_warning)
            else :

                if rows > 0 :
                    item = {}
                   
                    for row in range(rows):
                        try : infos = config.get(section,'zRow_%s' % (row))
                        except : break
                        widgetClassValues = infos.split("|")
                        
                        if len(widgetClassValues)< cols : break


                        if not (section == "tablemotsclefso" and widgetClassValues[0] == "0") :
                            try : obj.insertRow(row)
                            except : break 
                            
                            for col in range(cols) :
                                infos = config.get(section,'zWidget_%s' % (col))
                                widgetClassInfos = infos.rstrip().split("|")
                                widgetClassInfo = "%s" % (widgetClassInfos[0])
                                if widgetClassInfo == "standard" :
                                    item[col] = QTableWidgetItem()
                                    item[col].setText("%s" % (widgetClassValues[col]))
                                    obj.setItem(row,col, item[col])
                                else :
                                    if isIntNumber("%s" % widgetClassValues[col]) and widgetClassInfos[0] not in("QLineEdit","MySimpleWidgetLineEdit", "MyWidgetLineEdit") : value = int(widgetClassValues[col])
                                    elif isFloatNumber("%s" % widgetClassValues[col]) and widgetClassInfos[0] not in("QLineEdit", "MySimpleWidgetLineEdit", "MyWidgetLineEdit") : value = float(widgetClassValues[col])
                                    else : value = "%s" % (widgetClassValues[col])

                                    if int(widgetClassInfos[2])!= -1 : objWidget = addLineWidget(self, obj, row,  col, int(widgetClassInfos[1]), int(widgetClassInfos[2]), value)                                      
                                    else : objWidget = addLineWidget(self, obj, row,  col, int(widgetClassInfos[1]), int(widgetClassInfos[2]), ("%s" % (widgetClassValues[col-1]), value))

                                if obj.objectName() == "tablemotsclefso":
                                   widgetTarget = obj.cellWidget(row, col)
                                   if widgetTarget != None : 
                                       for irole in range(widgetTarget.count()) : widgetTarget.setItemData(irole, 33, Qt.UserRole -1)
                                       widgetTarget.setItemData(0, 0, Qt.UserRole -1)
                                       if int(widgetClassValues[0])==0 : widgetTarget.setEnabled(False)

                        if cols < maxCols :
                          for col in range(cols, maxCols, 1) :
                              params = self.paramsLineWidget[obj.objectName()] 
                              widget = addLineWidget(self, obj, row, col, params[col][0], params[col][1], params[col][2])

                        if obj.objectName() == "tableemprises":
                           obj.setToolTip("%s" % (obj.rowCount()-1))
                           self.drawExtent()

                        countItems(self, obj.objectName(), obj)

          
    else :
        msg = QApplication.translate("QSphere","Rows and Columns not find for Object : ")
        sendMsg(self, title , "%s%s" % (msg, section), Qgis.Warning, self.duration_warning)


def countItems(self, targetWidget, obj):
    labelObj = getWidget(self, "lbl%s" % (targetWidget))
    if labelObj :
        if type(obj) in (QTableWidget, myTableWidget) : labelObj.setText("(<b><u>%s</u></b>) %s" % (obj.rowCount(), labelObj.accessibleDescription()))
        elif type(obj) in (myWebComboBox, myUserComboBox, QComboBox): labelObj.setText("(<b><u>%s</u></b>) %s" % (obj.count(), labelObj.accessibleDescription()))

def analyzeInfosObj(self, config, obj, section):
    test, rows, cols = False, 0, 0
    try : infos = config.get(section,'zrows').rstrip()
    except :
        try : infos = config.get(section,'rows').rstrip()
        except : infos = ""
    if infos != "":
       if isIntNumber("%s" % infos) :
          rows = int(infos)
          try : infos = config.get(section,'zcols').rstrip()
          except :
              try : infos = config.get(section,'cols').rstrip()
              except : infos = ""
          if infos != "":
             if isIntNumber("%s" % infos) :
                cols = int(infos)
                test = True
    return test, rows, cols


def addLineWidget(self, obj, row,  col, targetWidget, subType, defaultValue):

        makeOwner = False if row >= 0 and col >=0 else True
   
        if targetWidget in (-1,-2) :
            if targetWidget == -1 :
                widget = MySimpleWidgetLineEdit(self) if makeOwner else MySimpleWidgetLineEdit()
            else :
                widget = MySimpleWidgetLineEditST(self) if makeOwner else MySimpleWidgetLineEditST()
                
            widgetFullName = "%s_qlineedit_%s_%s" % (obj.objectName(), row, col)
            if defaultValue != "" : widget.setText(defaultValue)
    
        if targetWidget == 0 :
            widget = MyWidgetLineEdit(self) if makeOwner else MyWidgetLineEdit()
            widget.initType(subType)
            widgetFullName = "%s_mywidgetlineedit_%s_%s" % (obj.objectName(), row, col)
            if subType == 2 : widget.setInputMask("99999;X")
            elif subType == 1 : widget.setInputMask("9999-99-99 9999-99-99;X")
            elif subType == 5 : widget.setInputMask("9999-99-99;X")
            widget.textChanged.connect(widget.checkRegExp)
            widget.setText(defaultValue)
            
        if targetWidget == 1 :
            widget = QPushButton(self)  if makeOwner else  QPushButton()
            widgetFullName = "%s_action_%s_%s" % (obj.objectName(), row, col)
            msg = QApplication.translate("QSphere","Call the SRS QGIS Dialog box") if obj.objectName() == "tablescr" else QApplication.translate("QSphere","Call the QSphere Formats Dialog box")
            widgetIcon = getThemeIcon("projection.png") if obj.objectName() == "tablescr" else getThemeIcon("format.png")
            widget.setToolTip(msg)
            widget.setIcon(QIcon(widgetIcon))
            widget.setIconSize(QSize(18,16))
            widget.clicked.connect(self.CallQgsProjectionSelector) if obj.objectName() == "tablescr" else widget.clicked.connect(self.CallFormatSelector)

        if targetWidget == 2 :
           widget = myComboBox(self) if makeOwner else myComboBox()
           widgetFullName = "%s_combobox_%s_%s" % (obj.objectName(), row, col)
           if subType == 0 :
               widget.addItems(self.listOfRules)
               if obj.objectName()=="tableroles" : widget.currentIndexChanged.connect(self.checkRules) 
           elif subType == 1 :
               widget.addItems(self.listOfThesaurus)
               for i in range(widget.count()) : widget.setItemData(i, 33, Qt.UserRole -1)
               widget.setItemData(0, 0, Qt.UserRole -1)
                              
               widgetFullName = "%s_ListItems_%s_%s" % (obj.objectName(), row, col)
               widget.currentIndexChanged.connect(self.listOfValues)
               try :
                   if self.sender().objectName()!= "" : defaultValue = 1
               except : defaultValue = 0 
               
           elif subType == 2 : widget.addItems(self.listTypeDates)
           elif subType == 3 : widget.addItems(self.listDegres)
           elif subType == 4 : widget.addItems(self.listFormats)
           elif subType == 5 :
               if not isIntNumber("%s" % defaultValue) :
                  if not defaultValue in self.listCountries : self.listCountries.append(u'%s' % (defaultValue))
                  index = self.listCountries.index(u'%s' % (defaultValue))
               else : index = defaultValue
               if index < 0 : index = 0
               widget.addItems(self.listCountries)
               widget.setEditable(True)
               widget.setCurrentIndex(index)
               widgetFullName = "%s_ListItems_%s_%s" % (obj.objectName(), row, col)
               widget.currentIndexChanged.connect(self.updatePatternZipPostalCode)
               
           elif subType == -1 :
               tempValue = defaultValue
               defaultValue = tempValue[1]
               if not self.sender() :
                   target = tempValue[0]
               else :    
                   target = 1 if self.sender().objectName()!= "" and self.sender().objectName()!="OpenForm_tablemotsclefso" else tempValue[0]
               sizeWidth, cols, iLine = loadFile(self, widget, "None", "file:200:thesaurus_%s_%s.csv:0:0" % (target, self.qspherePlugin.dicoLangs[self.qspherePlugin.indexLang]), 1, None)
           widget.setCurrentIndex(defaultValue) if not widget.isEditable() else widget.setCurrentIndex(index)
           if obj.objectName()=="tableroles" and subType == 0 and row < 2 : widget.setEnabled(False)

           if not obj.objectName().startswith("table"):
                 widget.view().setDragDropMode(QAbstractItemView.InternalMove)
                 widget.view().setDragDropMode(QAbstractItemView.OnlyDrag)
                 widget.setAcceptDrops(True)
           else : widget.view().setDragDropMode(QAbstractItemView.DragOnly)      

        if targetWidget == 3 :
           values = (51.9, 41.36, -5.79, 9.56)
           widgetName = ("latituden", "latitudes", "longitudeo", "longitudee")
           widget = mySpinBox(self)  if makeOwner else mySpinBox()
           widget.initDoubleSpinBox(self, None) if makeOwner else widget.initDoubleSpinBox(obj, self)

           if col in (2,3): propertiesDoubleSpinBox(self, widget, 8, -180, 180, 1)
           else : propertiesDoubleSpinBox(self, widget, 8, -90, 90, 1)
           widgetFullName = "%s_%s_%s_%s" % (obj.objectName(), widgetName[col], row, col)
           if defaultValue == -1 : widget.setValue(values[col])
           else : widget.setValue(float(defaultValue))
           widget.setMouseTracking(True)
           widget.setKeyboardTracking(False)
           if self.objectName() == "dlgMetadata" : widget.valueChanged.connect(self.drawExtent) 
               

        if targetWidget == 4 :
           widget = mySpinBox(self)  if makeOwner else mySpinBox()
           widget.initDoubleSpinBox(self, None) if makeOwner else widget.initDoubleSpinBox(obj, self)
           widgetFullName = "scalebox_line_%s" % (row)
           if obj.parent().children()[0].isChecked(): 
               propertiesDoubleSpinBox(self, widget, 0, 0, 10000000, 1000)
               if defaultValue==-1 : widget.setValue(25000)
               else : widget.setValue(defaultValue)
           else:
               propertiesDoubleSpinBox(self, widget, 4, 0, 1000, 10)
               if defaultValue == -1 : widget.setValue(float(2.0))
               else : widget.setValue(defaultValue)


        if targetWidget == 5 :
           widget = QPushButton(self)  if  makeOwner else QPushButton()
           widgetFullName = "%s_action_%s" % (obj.objectName(), row)
           widgetIcon = getThemeIcon("voir.png")
           widget.setIcon(QIcon(widgetIcon))
           widget.setIconSize(QSize(18,16))
           widget.clicked.connect(self.geoLocalisator)

        if targetWidget == 6 :
           widget = myCheckBox(self)  if  makeOwner else myCheckBox()
           widgetFullName = "%s_action_%s" % (obj.objectName(), row)
           widget.setToolTip(QApplication.translate("QSphere","From controlled Vocabulary "))
           widget.toggled.connect(self.setAccessibility)
           if type(defaultValue) != int : defaultValue = 2
           widget.setCheckState(defaultValue)
           
           
        if targetWidget == 7 :
            if obj.objectName() in ("tableformats","tablelocalisator", "tablescr"):
               typeObj = 6
               icon = getThemeIcon("supprimer.png") if row > 0 else getThemeIcon("supprimernone.png")
               toolTip = QApplication.translate("QSphere","Delete the current line") if row > 0 else QApplication.translate("QSphere","Can't delete the first line")
            buttonName = "del_%s_%s_%s" % (typeObj, obj.objectName(), row)
            widget = myPushButton(self) if makeOwner else myPushButton()
            widget.initPushButton(24, 24, 0, 0, buttonName, "", toolTip, True, icon, 24, 24, True)
            widgetFullName = "%s_mypushbutton_%s" % (obj.objectName(), row)

            if obj.objectName() in ("tableformats","tablelocalisator", "tablescr"):
               widget.clicked.connect(self.DelLineIndex) if row > 0 else widget.clicked.connect(self.deleteLine)
               

        widget.setObjectName(widgetFullName) 
        widget.setAccessibleDescription("%s|%s" % (targetWidget, subType))

        if not makeOwner : obj.setCellWidget(row, col, widget)

        return widget

def getAllItems(comboBox): return [comboBox.itemText(i) for i in range(comboBox.count())]

def propertiesDoubleSpinBox(self, obj, dec, minValue, maxValue, step):
        obj.setDecimals(dec)                
        obj.setMinimum(minValue)
        obj.setMaximum(maxValue)                
        obj.setSingleStep(step)

def dateToString(self, obj):
    try : pydate = obj.selectedDate()
    except :
        try : pydate = obj.date()
        except : pass
    theDate = "%s" % (pydate.toString('yyyy-MM-dd'))
    return theDate            


def reinitDate(obj):
    date = "%s" % (datetime.now())
    date = date.split(" ")[0]
    eltsDate = date.split("-")
    try : obj.setDate(QDate(int(eltsDate[0]), int(eltsDate[1]), int(eltsDate[2]))) 
    except :
        try : obj.setSelectedDate(QDate(int(eltsDate[0]), int(eltsDate[1]), int(eltsDate[2])))
        except : pass

def fileRessourceExist(self, inputFile):
    path = correctPath(dirname(__file__))
    path = path.replace("\\","/")
    fileName = inputFile.replace("file:///","")
    fileName = fileName.replace("file:","")
    fileName = fileName.replace("filexml:","")
    if exists(fileName) : return True, fileName

    fileCsv = "%s%s" % (path, inputFile.replace("file:",""))
    if exists(fileCsv) : return True, fileCsv

    nbSubElts, i = countCaractere(fileName, "_", False, False), 0
    if nbSubElts > 0 :
        rootFileName, listFiles = "", fileName.split(".")[0].split("_")
        i=0
        while i <= (nbSubElts-1) :
            rootFileName+= "_%s" % (listFiles[i]) if i > 0 else "%s" % (listFiles[i])
            i+=1
        posExtension = len(fileName.rsplit("."))
        fileExtension = fileName.rsplit(".")[posExtension-1]
        fileCsv = "%s%s.%s" % (path, rootFileName, fileExtension)

        if exists(fileCsv) : return True, fileCsv

    return False, ""

def loadData(self, inputFile, typeInfo):
    listData, dicoListData, i = [], {} , 0
    test, fileCsv = fileRessourceExist(self, inputFile)
    
    if fileCsv!= "" :
       f = open(fileCsv, "r", encoding="utf-8", errors="surrogateescape")
       while 1:
             text = f.readline()
             if text == "" : break
             if text.find(";")!=-1 :
                values = text.split(";")
                value = values[1].replace("\"","").rstrip()
                try : value = value.decode('utf-8')
                except : pass
                listData.append("%s" % (value))
                dicoListData[i]= values[0].replace("\"","").rstrip()
             else:
                value = text.replace("\"","").rstrip()
                try : value = value.decode('utf-8')
                except : pass                
                listData.append("%s" % (value))
             i+= 1
       f.close()
    else:
       if typeInfo == "roles":
           item0 = QApplication.translate("QSphere","Owner")
           item1 = QApplication.translate("QSphere","Point of contact")
           listData = [item0, item1]
           dicoListData[0]="owner"
           dicoListData[1]="pointOfContact"
       elif typeInfo == "langues" :
           item0 = QApplication.translate("QSphere","French")
           listData = [item0, item0]
           dicoListData[0]="fra"
           dicoListData[1]="fre"
       elif typeInfo == "thesaurus":
           listData = ["GEMET INSPIRE Themes"]
           dicoListData[0]="2008-06-01"
           
    return listData, dicoListData

def loadSimpleData(self, inputFile):
    listQuery = []
    test, fileName = fileRessourceExist(self, inputFile)
    if fileName != "" :
           with open(fileName, 'r', encoding="utf-8", errors="surrogateescape") as inFile : text = inFile.read().replace("\"","").rstrip()
           if text != "" : 
               tempoList = text.split("\n")
               for elt in tempoList : listQuery.append("%s" % (elt))
    return listQuery
    

def loadDefautValue(self, inputFile):
    dicoListData, i = {}, 0
    test, fileCsv = fileRessourceExist(self, inputFile)
    
    if fileCsv!= "" :
           f = open(fileCsv, "r", encoding="utf-8", errors="surrogateescape")
           while 1:
                 text = f.readline()
                 if text == "" : break
                 if text.find(";")!=-1 :
                    values = text.split(";")
                    listData = []
                    for j in range(len(values)):
                        value = values[j].replace("\"","").rstrip()
                        try : value = value.decode('utf-8')
                        except : pass                        
                        listData.append("%s" % (value))
                    dicoListData[i] = listData
                 else:
                    listData = []
                    value = text.replace("\"","").rstrip()
                    try : value = value.decode('utf-8')
                    except : pass                     
                    listData.append("%s" % (value))
                    dicoListData[0] = listData
                 i+= 1
           f.close()
    return dicoListData

def loadFile(self, obj, nameObj, target, typeObj, model):
    iLine, cols = 0, 0
    if model == None : model = QStandardItemModel()
    target = target.split(":")
    test, fileCsv = fileRessourceExist(self, "/ressources/%s" % (target[2]))
    useModel = int(target[3])
    useIcons = int(target[4])

    if fileCsv!= "" :
       if exists(fileCsv): 
           f = open(fileCsv, "r", encoding="utf-8", errors="surrogateescape")
           while 1:
               text = f.readline()
               if text == "" : break
               
               values = text.split(";")
               if cols == 0 : cols = len(values)
               if useModel == 1 :
                   if nameObj == "tablegroupedroits" : toolTip = values[1].replace("\"","").replace(",","\n").replace(":",":\n").rstrip()
                   for i in range(cols):
                       item = QStandardItem(True)
                       itemText = values[i].replace("\"","").rstrip()

                       try : itemText = itemText.decode('utf-8')
                       except : pass
                       
                       item.setText(itemText)
                       if i == 0 and typeObj == 3:    
                          item.setCheckable(True)
                          item.setCheckState(Qt.Unchecked)
                          if nameObj == "tablelangues" and itemText.startswith(self.localLangage): item.setCheckState(Qt.Checked)
                          
                       if nameObj == "tablegroupedroits" : item.setToolTip(textwrapfill(toolTip, 50)) 

                       item.setSelectable(True)
                       item.setDragEnabled(True) 
                       
                       item.setEditable(False)
                       model.setItem(iLine, i ,item)
               else:
                   if  typeObj == 1:
                       try : value = ("%s" % (values[0].decode('utf-8')))
                       except : value = ("%s" % (values[0]))
                       value = value.replace("\"","").rstrip()
                       if useIcons == 1 :
                           menuIcon = getThemeIcon("ressources/images/%s.png" % (value))
                           obj.addItem(QIcon(menuIcon), values[1].replace("\"","").rstrip(), "%s" % (value) )
                       else :    
                           obj.addItem("%s" % (value)) 
               iLine+= 1         
           f.close()

    if useModel == 1 :   
        view = QTableView()
        view.horizontalHeader().setVisible(False) 
        view.verticalHeader().setVisible(False)
        view.setSelectionBehavior(QAbstractItemView.SelectItems) 
        view.setSelectionMode(QAbstractItemView.SingleSelection)
        view.setDragDropMode(QAbstractItemView.DragOnly)        
        select = view.selectionModel()

        if typeObj == 1 :
            obj.setView(view)
            obj.setModel(model)
            obj.show()

        if nameObj == "tablecategories" : model.itemChanged.connect(self.selectKeyWord)

    return int(target[1]), cols, iLine

#----------------------------------------------
#FUNCTION TO MAKEWINDOWICO AND WINDOWPROPERTIES
#----------------------------------------------
def windowIcon(qtWindow, icon):
    if not qtWindow : return
    icon = getThemeIcon(icon)
    if icon != "" : qtWindow.setWindowIcon(QIcon(icon)) 

def windowProperties(targetObj, sourceObj):
    listProperties = ('version', 'iface', 'qspherePlugin', 'langue', 'languageIndex', 'langs', 'languesDico',
                'formats', 'listCodecs', 'listTemporalSystem', 'listTypeRessources', 'listCountries', 'indexCountry',
                'localeFullName', 'listCountriesCode', 'listOfRules', 'dictListOfRules', 'dicoLangs', 'typeData')

    for propertie in listProperties :
            try :  setattr(targetObj, propertie, getattr(sourceObj, propertie)) 
            except : setattr(targetObj, propertie, None)
            

    try : targetObj.localLangage = targetObj.localeFullName[0:2] if targetObj.localeFullName[0:2] in ("fr", "it", "fi", "es", "de") else "en"
    except : targetObj.localLangage = "en"
    
#--------------------------------------
# FUNCTIONS FOR CORRECTION IMAGES PATH 
#--------------------------------------
def getThemeIcon(theName):
    folders = list(syspath)
    folders.insert(0, "%s%s" % (correctPath(dirname(__file__)),"icons/"))
    folders.insert(0, "%s%s" % (correctPath(dirname(__file__)),"qsphere/"))
    folders.insert(0, "%s%s" % (correctPath(QgsApplication.pluginPath()),"qsphere/icons/"))
    for folder in folders :
        myPath = correctPath(folder)
        myIconPath = "%s%s" % (myPath, theName)
        if QFile.exists(myIconPath): return myIconPath
    return ""

def correctPath(path):
    path = "%s" % (path)
    a = len(path)
    letter = "/"
    b = path.rfind(letter, 0, a)
    return ("%s/" % (path)) if a != b else path 

def isCorrectLayer(layer, cond):
    if not layer: return False
    if not layer.type() == layer.VectorLayer: return False
    if not layer.isValid() : return False
    if not cond :
        if layer.geometryType() == QgsWkbTypes.Unknown: return False 
    else:
        if not layer.geometryType() == QgsWkbTypes.Point : return True
    return True

#-------------------------------------------------
#FUNCTION TEST IF NUMBER TYPE INT OR SUPPORT FLOAT
#-------------------------------------------------     
def isFloatNumber(s):
    result = False
    try :
        if s.count(".") == 1 :
            if s.replace(".", "").isdigit(): result = True
    except : pass        
    return result    

#-----------------------------------------------
#FUNCTION TEST IF NUMBER TYPE INT OR SUPPORT INT
#-----------------------------------------------    
def isIntNumber(s):
    try : return not(set(s)-set(digits))
    except :
        try : return int(s)
        except : return False

#---------------------------------
# FUNCTION TO COUNT SUBSTR IN STR
#---------------------------------
def countCaractere(text, words, ignoreCase, wholeword):
    countCaractere = 0
    import re
    if wholeword == True : words = (r'\b%s\b' % (words))
    if ignoreCase == False : countCaractere = len(re.findall(re.compile(words, re.IGNORECASE), text))
    else : countCaractere = len(re.findall(words, text)) 
    return countCaractere


def getHelp(self):
    partName = QApplication.translate("QSphere","user manual")
    fileName = "qsphere_%s_%s.pdf" % (partName, self.dicoLangs[self.indexLang])
    test, fullFileName = fileRessourceExist(None, "help/%s" % fileName)
    isOpen = False
    
    if test : 
        try : webbrowseropen(fullFileName); isOpen = True;
        except : pass
    else :
        url = "https://www.google.fr/#q=QSphere+%s" % self.version
        try : webbrowseropen(url); isOpen = True;
        except : pass

    if not isOpen :    
       title = QApplication.translate("QSphere","Warning")
       msg = QApplication.translate("QSphere","Error")
       sendMsg(self, title , "%s<br>%s" % (msg, fileName), Qgis.Warning, 5)
     

#------------------------
# FUNCTION QGSMESSAGEBAR
#------------------------
def sendMsg(self, title , msg, level, duration):
      icon = getThemeIcon("qsphere_msgbox.png") 

      try : self.editorMsg = myTextEdit()
      except : return
      
      self.editorMsg.initTextEdit(680, 240, 5, 150, "ViewLOG", True, False, True, False, False)
      html = "<html><table border='0'><tr valign='middle'><td><img src='%s'></td><td><h4>%s</h4></td></tr></table></html>" % (icon, msg.replace("\\n", "<br>"))
      self.editorMsg.setText(html)
      self.editorMsg.setGeometry(50,5, 200,50)
      try : duration = int(duration)
      except : duration = 2
      if level == Qgis.Warning : self.editorMsg.setStyleSheet("color: black; background-color: #FFC800; border: 0px")
      elif level == Qgis.Info : self.editorMsg.setStyleSheet("color: black; background-color: #E7F5FE; border: 0px")
      self.barInfo.pushWidget(self.editorMsg, level, int(duration))
      return self.editorMsg

#------------------------------
# FUNCTION FIXELABELSFILEDIALOG
#------------------------------
def fixeLabelsFileDialog(self, dlgFile, context, hasName):

    dlgFile.setLabelText(QFileDialog.Accept, QApplication.translate("QSphere","Open")) if context == 0 else dlgFile.setLabelText(QFileDialog.Accept, QApplication.translate("QSphere","Save"))
    dlgFile.setLabelText(QFileDialog.Reject, QApplication.translate("QSphere","Cancel"))        
    dlgFile.setLabelText(QFileDialog.FileName, "%s : " % (QApplication.translate("QSphere","Name"))) if hasName else dlgFile.setLabelText(QFileDialog.FileName, QApplication.translate("QSphere","Folder : "))
    dlgFile.setLabelText(QFileDialog.FileType, QApplication.translate("QSphere","Filters : "))
    dlgFile.setLabelText(QFileDialog.LookIn, QApplication.translate("QSphere","Folder : "))

#------------------------------
# FUNCTION MARKERTEXT
#------------------------------
def markerText(self, text):
  text = text.replace("\n", "<br>")
  pos = text.find("=")
  if pos != -1 :
     text0 = text[0:pos-1]
     text1 = text[pos+1:]
     text = "<font style='color:#009900;'>%s</font> <b>=</b> %s" % (text0, text1) 
  else :   
    text = text.replace("[", "[<font style='color:#FFFFCC; background-color: #0000ff; font-weight:bold'>")
    text = text.replace("]", "</font>]")
  return text

#------------------------------
# FUNCTION FILEINFOSTOHTML
#------------------------------
def fileInfosToHtml(self, inputFile):

   html = "<style>table {border-spacing: 0px; width: 100%}"
   html+= "td {padding: 5px 30px 5px 10px;border-spacing: 0px;font-size: 90%;margin: 0px;}"
   html+= "td {color: #737476;text-align: left;background-color: #e0e9f0;border-top: 1px solid #f1f8fe; border-bottom: 1px solid #0099ff; border-right: 1px solid #0099ff;}"
   html+= "</style>" 
   html+= "<table>"

   extension = inputFile.suffix().lower()
   icon = getThemeIcon("mime/file/%s.png" % (extension))
   if icon == "" : icon = getThemeIcon("mime/file/unknow.png")
   
   html+= "<tr valign='middle'><td colspan=2><img src='%s' width=32 height=32> %s :<h3>%s.%s</h3></td></tr>" % (icon, QApplication.translate("QSphere", "file"), inputFile.baseName(), extension)
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Folder"), dirname(inputFile.filePath()))
   owner = QApplication.translate("QSphere","Unknow") if inputFile.owner() == "" else inputFile.owner()
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Owner"), owner)
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Date creation"), inputFile.created().toString('yyyy-MM-dd hh:mm:ss'))
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Date last modification"), inputFile.lastModified().toString('yyyy-MM-dd hh:mm:ss'))
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Date last access"), inputFile.lastRead().toString('yyyy-MM-dd hh:mm:ss'))
   html+= "<tr><td>%s :</td><td>%s</td></tr>" % (QApplication.translate("QSphere", "Size"), formatedSize(inputFile.size()))
   html+= "<tr><td colspan=2><u>%s</u> :<ul>" % (QApplication.translate("QSphere", "Rights"))

   if (inputFile.permission(QFile.ReadUser))  : html+= "<li>%s</li>" % (QApplication.translate("QSphere","I can read the file"))
   if (inputFile.permission(QFile.WriteUser)) : html+= "<li>%s</li>" % (QApplication.translate("QSphere","I can change the file"))
   if (inputFile.permission(QFile.ReadGroup)) : html+= "<li>%s</li>" % (QApplication.translate("QSphere","My group can read the file"))
   if (inputFile.permission(QFile.WriteGroup)): html+= "<li>%s</li>" % (QApplication.translate("QSphere","My group can change the file"))   
   if (inputFile.permission(QFile.WriteOther)): html+= "<li>%s</li>" % (QApplication.translate("QSphere","Orthers can change the file"))   

   html+= "</ul></td></tr></table>"
   html+= "<sup>%s</sup>" % (QApplication.translate("QSphere", "Double clic to open file !"))

   return html


#------------------------------
# FUNCTION GETFORMATEDSIZE
#------------------------------
def formatedSize(size, precision=2):
    suffixes=["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"]
    suffixIndex = 0
    while size > 1024:
        suffixIndex += 1 
        size = size/1024.0 
    return "%.*f %s" % (precision,size,suffixes[suffixIndex])

#------------------------------
# FUNCTION FILEISRASTER
#------------------------------
def isRasterFile(fichier):
    isRaster = False
    try : isRaster = gdalopen(fichier)
    except : pass
    return isRaster

#------------------------------
# FUNCTION TXTFORNAMEWINDOW
#------------------------------
def txtForNameWindow(self, counter):
    listaplha = "abcdefghijklmnopqrstuvwxyz"
    nbmodulo = (counter /26) if counter >= 26 else 0
    reste = counter-(nbmodulo*26)
    textwindow = ""
    if nbmodulo>0 :
        for i in range(nbmodulo): textwindow+= "%s" % listaplha[23]
    if reste >0 : textwindow+= "%s" % listaplha[reste-1]
    return textwindow

#------------------------------
# FUNCTION convertToUtf8
#------------------------------
def convertToUtf8(str): return unquote(str) 
