<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:gco="http://www.isotc211.org/2005/gco"
	xmlns:gmd="http://www.isotc211.org/2005/gmd"
	xmlns:gfc="http://www.isotc211.org/2005/gfc"
	xmlns:gmx="http://www.isotc211.org/2005/gmx"
	xmlns:gts="http://www.isotc211.org/2005/gts"
	
	xmlns:gml="http://www.opengis.net/gml"
	xmlns:csw="http://www.opengis.net/cat/csw/2.0.2"
	
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"

	xmlns:geonet="http://www.fao.org/geonetwork"	

	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
<xsl:output version="4.01" omit-xml-declaration="yes" method="html" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd" indent="yes"/>
<xsl:variable name="fileMapping" select="document('./contacts.xsl')"/>   
<xsl:template match='/'>
<html><head>
<style type="text/css" media="all" >
    /** {font: normal 1em verdana, arial, sans-serif; color:#000; vertical-align: top; text-align: center;}*/
    #page {width: 780px; text-align: center; margin: auto; font: normal 0.93em verdana, arial, sans-serif; color:#000; vertical-align: top; }
    #page .type {page-break-before: always; text-align: right; font: bold 0.8em verdana, arial, sans-serif; margin-top: 10px;}
    #page .t {font: bold 2em verdana, arial, sans-serif; text-align:center; line-height:1.8em; border: 1px solid #000000; background-color: #a6bddb;}
    
	
	#page table {border-spacing: 0px; width: 100%}
	#page th, td {padding: 5px 30px 5px 10px;border-spacing: 0px;font-size: 90%;margin: 0px;}
	#page th, td {color: #737476;text-align: left;background-color: #e0e9f0;border-top: 1px solid #f1f8fe;border-bottom: 1px solid #cbd2d8;	border-right: 1px solid #cbd2d8;}
	#page tr.head th {color: #fff;background-color: #90b4d6; border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6;text-align: left;text-shadow: -1px -1px 1px #666; letter-spacing: 0.15em;}
	#page tr.head th:first-child {-webkit-border-top-left-radius: 5px;-moz-border-radius-topleft: 5px;border-top-left-radius: 5px;}
	#page tr.head th:last-child {-webkit-border-top-right-radius: 5px;-moz-border-radius-topright: 5px;border-top-right-radius: 5px;}	
    #page tr.headTitle th {font-size: 150%; color: #fff;background-color: #00b4FF;	border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6;text-align: center;text-shadow: -1px -1px 1px #666;letter-spacing: 0.15em; }
	#page tr.headTitle th:first-child {-webkit-border-top-left-radius: 10px;-moz-border-radius-topleft: 10px;border-top-left-radius: 10px; -webkit-border-bottom-left-radius: 10px;-moz-border-radius-bottomleft: 10px;border-bottom-left-radius: 10px;}
	#page tr.headTitle th:last-child {-webkit-border-top-right-radius: 10px;-moz-border-radius-topright: 10px;border-top-right-radius: 10px; -webkit-border-bottom-right-radius: 10px;-moz-border-radius-bottomright: 10px;border-bottom-right-radius: 10px;}
	#page td {text-shadow: 1px 1px 1px #fff;}
	#page tr.even td, tr.even th {	background-color: #e8eff5;} 


    #page .partie {font-weight: bold; border: 0px solid #000000; background-color: #a6bddb; }
	#page .partietd {font-weight: bold; border: 0px solid #000000; background-color: #a6bddb; text-align: center;}
    #page .td1 {width: 130px; vertical-align: top;}
	#page .tdrupture {width: 130px; vertical-align: top; background-color: #ffffff;}	
    #page .titre {font-weight: bold; text-align: center;}
    #page .td2 { text-align: justify; white-space : pre-wrap; }
	#page .td2c { text-align: justify; white-space : pre-wrap; text-align: center; }
	#page .td2left { text-align: left;}
	#page .ul1 {list-style-type:none; margin-top:0px; margin-bottom:0px; padding: 0px;} 
	#page .ul2 {margin-top:0px; margin-bottom:0px; padding: 10px;} 
	#page .li1 {margin-top:0px; } 
    #page .tb_cnt {background:#fff; border: 1px solid #000000; font:1.2em verdana, arial, sans-serif; border-collapse:collapse; margin: 5px; width: 98%;}
    #page .td1_cnt {width: 400px; border: 1px solid #000000;}
    #page .td2_cnt {width: 200px;; border: 1px solid #000000;}
    #page .note {font-size: 0.7em; font-style: italic; text-align: right; margin-bottom: 30px;}
    #page .retour {padding: 5px 5px 10px 5px; text-align: left; text-decoration: none;}
</style>
</head>
<body>
    <div id="page">
        <xsl:apply-templates/>
    </div>
</body>
</html>
</xsl:template >

<xsl:template match="gmd:MD_Metadata">  
	<table>
	  <tr class="headTitle"><th>List of contacts</th></tr>
	</table>  
    <br/>

	<table>	 
		<tr class="head"><th colspan="2">Contact(s)</th></tr>
		<xsl:for-each select="gmd:identificationInfo/gmd:MD_DataIdentification/gmd:pointOfContact">
		 <xsl:variable name="MyType">
			 	<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:role/gmd:CI_RoleCode"/>
		 </xsl:variable>
			 <tr>
				<td class="td1">
				<img src="./../../icons/contact.png" height="24" width="24" alt="Collapse Thread"/>
				Organization :</td>
				 <td class="titre td2"><xsl:value-of select="gmd:CI_ResponsibleParty/gmd:organisationName/gco:CharacterString"/></td>
			</tr>
			<tr>
				<td class="td1">Role :</td>
				 <td class="titre td2">
					 <xsl:value-of select="$MyType"/>
				 </td>
			</tr>
			<tr>
			<td class="td1">Adress :</td>
			<td class="td2"> 
			<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:deliveryPoint/gco:CharacterString"/> <br />
			<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:postalCode/gco:CharacterString"/> <br />
			<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:city/gco:CharacterString"/> </td>
		  </tr>  
		  <tr>
			<td class="td1">Email :</td>
			<td> 
			<a>
				<xsl:attribute name="href">
					<xsl:text>mailto:</xsl:text>
					<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:electronicMailAddress/gco:CharacterString"/> 
				</xsl:attribute>
					<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:electronicMailAddress/gco:CharacterString"/>			
			</a>
			</td>
		  </tr>
<xsl:if test="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice">
	  <tr>
        <td class="td1">Phone :</td>
        <td class="td2"> <xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice/gco:CharacterString"/></td>
      </tr>
</xsl:if>
<xsl:if test="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:facsimile">
	  <tr>
        <td class="td1">facsimile :</td>
        <td class="td2"> <xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:facsimile/gco:CharacterString"/></td>
      </tr>
</xsl:if>
<xsl:if test="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:onlineResource/gmd:CI_OnlineResource/gmd:linkage">
      <tr>
        <td class="td1">URL :</td>
        <td> 
		<xsl:text>web site : </xsl:text>
		<a>
			<xsl:attribute name="href">
				<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:onlineResource/gmd:CI_OnlineResource/gmd:linkage/gmd:URL"/> 
			</xsl:attribute>
				<xsl:value-of select="gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:onlineResource/gmd:CI_OnlineResource/gmd:linkage/gmd:URL"/>
		</a>
		</td>
      </tr>
</xsl:if>
		  <tr><td colspan="2" class="tdrupture"></td></tr>
  </xsl:for-each>
  </table>
  <br/>
</xsl:template>

</xsl:stylesheet>
