<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:gco="http://www.isotc211.org/2005/gco"
	xmlns:gmd="http://www.isotc211.org/2005/gmd"
	xmlns:gfc="http://www.isotc211.org/2005/gfc"
	xmlns:gmx="http://www.isotc211.org/2005/gmx"
	xmlns:gts="http://www.isotc211.org/2005/gts"
	
	xmlns:gml="http://www.opengis.net/gml"
	xmlns:csw="http://www.opengis.net/cat/csw/2.0.2"
	
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"

	xmlns:geonet="http://www.fao.org/geonetwork"	

	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
<xsl:output version="4.01" omit-xml-declaration="yes" method="html" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd" indent="yes"/>
<xsl:variable name="fileMapping" select="document('./dictionnaire.xsl')"/>   
<xsl:template match='/'>
<html><head>
<style type="text/css" media="all" >
    /** {font: normal 1em verdana, arial, sans-serif; color:#000; vertical-align: top; text-align: center;}*/
    #page {width: 100%; text-align: center; margin: auto; font: normal 0.93em verdana, arial, sans-serif; color:#000; vertical-align: top; }
    #page .type {page-break-before: always; text-align: right; font: bold 0.8em verdana, arial, sans-serif; margin-top: 10px;}
    #page .t {font: bold 2em verdana, arial, sans-serif; text-align:center; line-height:1.8em; border: 1px solid #000000; background-color: #a6bddb;}
    
	
	#page table {border-spacing: 0px; width: 100%;  margin-left:auto; margin-right:auto;}
	#page th, td {padding: 5px 30px 5px 10px;border-spacing: 0px;font-size: 90%;margin: 0px;}
	#page th, td {color: #737476;text-align: left;background-color: #e0e9f0;border-top: 1px solid #f1f8fe;border-bottom: 1px solid #cbd2d8;	border-right: 1px solid #cbd2d8;}
	#page tr.head th {color: #fff;background-color: #90b4d6; border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6;text-align: left;text-shadow: -1px -1px 1px #666; letter-spacing: 0.15em;}
	#page tr.head th:first-child {-webkit-border-top-left-radius: 5px;-moz-border-radius-topleft: 5px;border-top-left-radius: 5px;}
	#page tr.head th:last-child {-webkit-border-top-right-radius: 5px;-moz-border-radius-topright: 5px;border-top-right-radius: 5px;}
    #page tr.headTitle th {font-size: 150%; color: #fff;background-color: #00b4FF;	border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6;text-align: center;text-shadow: -1px -1px 1px #666;letter-spacing: 0.15em; }
	#page tr.headTitle th:first-child {align :"center"; -webkit-border-top-left-radius: 10px;-moz-border-radius-topleft: 10px;border-top-left-radius: 10px; -webkit-border-bottom-left-radius: 10px;-moz-border-radius-bottomleft: 10px;border-bottom-left-radius: 10px;}
	#page tr.headTitle th:last-child {-webkit-border-top-right-radius: 10px;-moz-border-radius-topright: 10px;border-top-right-radius: 10px; -webkit-border-bottom-right-radius: 10px;-moz-border-radius-bottomright: 10px;border-bottom-right-radius: 10px;}
	#page td {text-shadow: 1px 1px 1px #fff;}
	#page tr.even td, tr.even th {	background-color: #e8eff5;} 


	#page .partie {font-weight: bold; border: 0px solid #000000; background-color: #a6bddb; }
	#page .partietd {font-weight: bold; border: 0px solid #000000; background-color: #a6bddb; text-align: center;}
	#page .td1 {width: 50px; vertical-align: top;}
	#page .tdrupture {width: 130px; vertical-align: top; background-color: #ffffff;}
	#page .titre {font-weight: bold; text-align: center;}
	#page .td2Xxl { text-align: center; font-size: 150%; color: #000;background-color: #FFFFCC; border-bottom: 2px solid #547ca0;border-right: 1px solid #749abe;border-top: 1px solid #90b4d6;text-shadow: -1px -1px 1px #666; letter-spacing: 0.15em; }
	#page .td2Xxl:first-child {-webkit-border-top-left-radius: 5px;-moz-border-radius-topleft: 5px;border-top-left-radius: 5px;}
	#page .td2Xxl:last-child {-webkit-border-top-right-radius: 5px;-moz-border-radius-topright: 5px;border-top-right-radius: 5px;}
	#page .td2 { text-align: justify; white-space : pre-wrap; }
	#page .td2c { text-align: justify; white-space : pre-wrap; text-align: center; }
	#page .td2left { text-align: left;}
	#page .ul1 {list-style-type:none; margin-top:0px; margin-bottom:0px; padding: 0px;} 
	#page .ul2 {margin-top:0px; margin-bottom:0px; padding: 10px;} 
	#page .li1 {margin-top:0px; } 
	#page .tb_cnt {background:#fff; border: 1px solid #000000; font:1.2em verdana, arial, sans-serif; border-collapse:collapse; margin: 5px; width: 98%;}
	#page .td_cnt {width: 400px; border: 1px solid #000000; text-align: justify;}
	#page .note {font-size: 0.7em; font-style: italic; text-align: right; margin-bottom: 30px;}
	#page .retour {padding: 5px 5px 10px 5px; text-align: left; text-decoration: none;}
</style>
</head>
<body>
    <div id="page">
        <xsl:apply-templates/>
    </div>
</body>
</html>
</xsl:template >

<xsl:template match="datasetinfo">  
	<table align="center">
	  <tr class="headTitle"><th>Mtadonnes lmentaires</th></tr>
		<xsl:if test="title">
			 <tr>
				<td class="td2Xxl" colspan="3"><xsl:value-of select="title"/></td>
			</tr>
		</xsl:if>
		<xsl:if test="description">
			 <tr>
				<td class="td_cnt" colspan="3">
					<xsl:value-of select="description"/>
				</td>
			</tr>
		</xsl:if>
	  </table>
<br/>

	<table>
		<tr class="head"><th></th><th>Nom</th><th>Valeur</th></tr>
		
		<xsl:if test="metadatas/format">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Format</td>
				 <td class="td2left"><xsl:value-of select="metadatas/format"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/origin">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Source</td>
				 <td class="td2left"><xsl:value-of select="metadatas/origin/@url"/></td>
			</tr>
		  <tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		
		
		
		<xsl:if test="metadatas/projection">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Projection</td>
				 <td class="td2left">
				 <xsl:call-template name="text_wrapper"> 
					<xsl:with-param name="text" select="metadatas/projection"/> 
						<xsl:with-param name="width" select="100"/> 
				</xsl:call-template>
				 
</td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		
		
		
		
		
		
		<xsl:if test="metadatas/projectionCode">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Code du systme de projection</td>
				 <td class="td2left"><xsl:value-of select="metadatas/projectionCode"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/extent">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Etendue</td>
				 <td class="td2left"><xsl:value-of select="metadatas/extent"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>


		
		
		
		<xsl:if test="metadatas/version">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Version</td>
				 <td class="td2left"><xsl:value-of select="metadatas/version"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/geographicextent">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Etendue gographique</td>
				 <td class="td2left">
						westBoundLongitude : <xsl:value-of select="metadatas/geographicextent/westBoundLongitude"/><br/>
						eastBoundLongitude : <xsl:value-of select="metadatas/geographicextent/eastBoundLongitude"/><br/>
						northBoundLatitude : <xsl:value-of select="metadatas/geographicextent/northBoundLatitude"/><br/>
						southBoundLatitude : <xsl:value-of select="metadatas/geographicextent/southBoundLatitude"/><br/>
				</td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/layertype">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Type de couche</td>
				 <td class="td2left"><xsl:value-of select="metadatas/layertype"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/geometryType">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Type de gomtrie</td>
				 <td class="td2left"><xsl:value-of select="metadatas/geometryType"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/publicationDate">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Date de publication</td>
				 <td class="td2left"><xsl:value-of select="metadatas/publicationDate"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/lastdate">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Dernire date</td>
				 <td class="td2left"><xsl:value-of select="metadatas/lastdate"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/lastRevisionDate">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Dernire date de rvision</td>
				 <td class="td2left"><xsl:value-of select="metadatas/lastRevisionDate"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/nbFeatures">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">nombre d'enregistrements</td>
				 <td class="td2left"><xsl:value-of select="metadatas/nbFeatures"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/length">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">longueur</td>
				 <td class="td2left"><xsl:value-of select="metadatas/length"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>
		<xsl:if test="metadatas/documented">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">documentation</td>
				 <td class="td2left"><xsl:value-of select="metadatas/documented"/></td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>

		<xsl:if test="metadatas/contact">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Contact</td>
				 <td class="td2left">
					<xsl:value-of select="metadatas/contact/name"/><br/>
					<xsl:value-of select="metadatas/contact/email"/>
				 </td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>

		<xsl:if test="keywords">
			 <tr>
				<td class="td1">
				<img src="./../../icons/unknow.png" height="32" width="32" alt="Collapse Thread"/></td>
				 <td class="titre td2">Mots clefs</td>
				 <td class="td2left">
					<ul class="ul1"> 
						<xsl:for-each select="keywords/key">
							<li class="li1"> - <xsl:value-of select="."/></li>
						</xsl:for-each>
					</ul>
				</td>
			</tr>
		<tr><td colspan="3" class="tdrupture"></td></tr>
		</xsl:if>






  </table>
<br/>
</xsl:template>

<xsl:template name="text_wrapper"> 
<xsl:param name="text"/> 
<xsl:param name="width" select="20"/> 

<xsl:if test="string-length($text)"> 
  <xsl:value-of select="substring($text, 1, $width)"/><br/> 
  <xsl:call-template name="text_wrapper"> 
    <xsl:with-param name="text" 
     select="substring($text, $width + 1)"/> 
    <xsl:with-param name="width" select="$width"/> 
  </xsl:call-template> 
</xsl:if> 
</xsl:template>


</xsl:stylesheet>
