<xsl:stylesheet version="1.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:strip-space elements="*"/>

<xsl:template match="/">
<style>
input { display: none;}
input ~ ul {display: none;}
input:checked ~ ul { display: block;}
input ~ .fa-angle-double-down { display: none;}
input:checked ~ .fa-angle-double-right {display: none;}
input:checked ~ .fa-angle-double-down {display: inline;}

/* habillage */
li {display: list-item;font-family: 'Arial'; font-size: 15px; padding: 0.2em; border: 1px solid transparent;}
li:hover { border: 1px solid grey; border-radius: 3px; background-color: lightgrey;}
</style>
        <xsl:apply-templates/>
</xsl:template>

<xsl:template match="*">
	<ul>
    <li>
        <xsl:value-of select="name()" />
          <input type="checkbox"/>
          <i class="fa fa-angle-double-right" />
          <i class="fa fa-angle-double-down" />
        <xsl:if test="text()">
          <label><xsl:value-of select="text()"/></label>
            <xsl:text>: </xsl:text>
            <xsl:apply-templates select="text()" />
        </xsl:if>
        <xsl:if test="*">
            <ul>
                <xsl:apply-templates/>
            </ul>
        </xsl:if>
    </li>
	</ul>
</xsl:template>

  <xsl:template match="*[*]">
    <input type="checkbox"/>
      <i class="fa fa-angle-double-right" />
      <i class="fa fa-angle-double-down" />
      <label><xsl:value-of select="text()"/></label>
        <ul>
            <li><xsl:value-of select="name()"/>
              <xsl:apply-templates/>
            </li>
        </ul>
  </xsl:template>
  
</xsl:stylesheet>