<?xml version="1.0" encoding="UTF-8"?>

<!-- 
ISO 19139 default stylesheet
Based on metadata-iso19139.xsl from exCat
http://gdsc.nlr.nl/gdsc/en/tools/excat

/***************************************************************************
 Metadata browser/editor
                             
        begin                : 2011-02-21
        copyright            : (C) 2011 by NextGIS
        email                : info@nextgis.ru
        traduction Spanish   : Samuel Mesa 
        Team traduction      : GeoTux - http://geotux.co
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 <xsl:output method="html" encoding="ISO-8859-1"/>	 
-->

<xsl:stylesheet version="1.0" 
	xmlns:gco="http://www.isotc211.org/2005/gco"
	xmlns:gmd="http://www.isotc211.org/2005/gmd"
	xmlns:gfc="http://www.isotc211.org/2005/gfc"
	xmlns:gmx="http://www.isotc211.org/2005/gmx"
	xmlns:gts="http://www.isotc211.org/2005/gts"
	
	xmlns:gml="http://www.opengis.net/gml"
	xmlns:csw="http://www.opengis.net/cat/csw/2.0.2"
	
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"

	xmlns:geonet="http://www.fao.org/geonetwork"	

	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
<xsl:output method="html" encoding="UTF-8"/>

<xsl:template name="tablerow" >
    <xsl:param name="cname"/>
    <xsl:param name="cvalue"/>
	
	<xsl:variable name="svalue">
					 <xsl:if test="$cvalue='owner'">
						<xsl:value-of select="'Proprietario'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='pointOfContact'">
						<xsl:value-of select="'Punto de contacto'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='resourceProvider'">
						<xsl:value-of select="'Proveedor del recurso'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='custodian'">
						<xsl:value-of select="'Custodia'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='user'">
						<xsl:value-of select="'Usuario'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='distributor'">
						<xsl:value-of select="'Distribuidor'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='originator'">
						<xsl:value-of select="'Orginador'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='principalInvestigator'">
						<xsl:value-of select="'Investigador principal'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='processor'">
						<xsl:value-of select="'Integrador'"/>
					 </xsl:if>
					 
					 <xsl:if test="$cvalue='publisher'">
						<xsl:value-of select="'Editor'"/>
					 </xsl:if>
    </xsl:variable>

    <xsl:choose>
	<xsl:when test="contains($cname, 'URL site web')">
	  <tr>
          <td class="meta-param">
            <xsl:value-of select="$cname"/>
            <xsl:text>: </xsl:text>
          </td>
          <td class="meta-value">
		  <a>
			<xsl:attribute name="href">
				<xsl:value-of select="$cvalue"/>
			</xsl:attribute>
			<xsl:value-of select="$cvalue"/>
			</a>
		  
          </td>
        </tr>
	</xsl:when>
	<xsl:when test="contains($cname, 'Role')">
        <tr>
          <td class="meta-param">
            <xsl:value-of select="$cname"/>
            <xsl:text>: </xsl:text>
          </td>
          <td class="meta-value">
            <xsl:value-of select="$svalue"/>
          </td>
        </tr>
      </xsl:when>
	<xsl:when test="string($cvalue)">
        <tr>
          <td class="meta-param">
            <xsl:value-of select="$cname"/>
            <xsl:text>: </xsl:text>
          </td>
          <td class="meta-value">
            <xsl:value-of select="$cvalue"/>
          </td>
        </tr>
      </xsl:when>
      <xsl:otherwise>
	  </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
<xsl:template match="gmd:MD_Metadata">
   
<!-- Metadata block -->
 
 <html>
   <head>
   	 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  	 <style type="text/css">
 	.captioneddiv { margin: 2em 0em 0em 0em; padding: 1em; height:auto;	border: solid #2A669D 1px;	background: #ffffff; }
	.captioneddiv h3 { position: relative;  margin: 0.5em;  top: -2.0em;  left: -1.0em; padding: 0em 0.5em; display: inline;
					   font-size: 0.9em; /*background: #cae1ff;*/  background: #ffffff; }					
	.meta { vertical-align: top; }
	.meta-param { vertical-align: top; color: #004393 }
	.meta-value { vertical-align: top;}
	</style>
   </head>
   <body>
<div class="captioneddiv">
<h3>Metadatos</h3>
<table class="meta"><tr></tr>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Identificador del fichero'"/>
      <xsl:with-param name="cvalue" select="./gmd:fileIdentifier/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Idioma'"/>
      <xsl:with-param name="cvalue" select="./gmd:language/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Codificación'"/>
      <xsl:with-param name="cvalue" select="./gmd:characterSet/gmd:MD_CharacterSetCode/@codeListValue"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Fecha'"/>
      <xsl:with-param name="cvalue" select="./gmd:dateStamp/gco:Date"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Estándar de metadato'"/>
      <xsl:with-param name="cvalue" select="./gmd:metadataStandardName/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Versión del estándar'"/>
      <xsl:with-param name="cvalue" select="./gmd:metadataStandardVersion/gco:CharacterString"/>
      </xsl:call-template>
</table>
 
<xsl:apply-templates select="./gmd:contact"/>
</div> 

<!-- Identification block -->
<xsl:apply-templates select="./gmd:identificationInfo/gmd:MD_DataIdentification"/>

<!--  Distribution -->
<xsl:apply-templates select="./gmd:distributionInfo/gmd:MD_Distribution"/>

<!-- ContentInfo -->
<xsl:apply-templates select="./gmd:contentInfo"/>

<!--  DataQuality -->
<xsl:apply-templates select="./gmd:dataQualityInfo/gmd:DQ_DataQuality"/>
  		
   </body>
 </html>
</xsl:template>


<!-- 'Metadata->Metadata author' block -->
<xsl:template match="gmd:contact">
<div class="captioneddiv">
<h3>Autor del metadato</h3>
<table class="meta">
<tr>
<td class="meta" valign="top">
<table class="meta"><tr></tr>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Nombre'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:individualName/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Organización'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:organisationName/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Posición'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:positionName/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Role'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:role/gmd:CI_RoleCode/@codeListValue"/>
      </xsl:call-template>
</table></td>
<td class="meta" valign="top">
<table class="meta"><tr></tr>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Teléfono'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Fax'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:facsimile/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Dirección'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:deliveryPoint/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Ciudad'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:city/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Código Postal'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:postalCode/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'País'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:country/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Correo electrónico'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:electronicMailAddress/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Téléfono'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'URL del Sitio Web'"/>
      <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:onlineResource/gmd:CI_OnlineResource/gmd:linkage/gmd:URL"/>
      </xsl:call-template>
</table></td>
</tr>
</table>
</div>
</xsl:template>


<!-- 'Identification' block -->
<xsl:template match="gmd:MD_DataIdentification">
<div class="captioneddiv">
<h3>Información de identificación</h3>
<table class="meta"><tr></tr>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Título'"/>
      <xsl:with-param name="cvalue" select="./gmd:citation/gmd:CI_Citation/gmd:title/gco:CharacterString"/>
      </xsl:call-template>
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Fecha'"/>
      <xsl:with-param name="cvalue" select="./gmd:citation/gmd:CI_Citation/gmd:date/gmd:CI_Date/gmd:data/gco:Date"/>
      </xsl:call-template>
      <!--xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Presentation form'"/>
      <xsl:with-param name="cvalue" select="./idCitation/presForm/PresFormCd/@value"/>
      </xsl:call-template-->
	  <xsl:for-each select="./gmd:pointOfContact/gmd:CI_ResponsibleParty/gmd:organisationName">
		<xsl:call-template name="tablerow">
		<xsl:with-param name="cname" select="'Nombre'"/>
		<xsl:with-param name="cvalue" select="./gmd:pointOfContact/gmd:CI_ResponsibleParty/gmd:individualName/gco:CharacterString"/>
		</xsl:call-template>
		<xsl:call-template name="tablerow">
		<xsl:with-param name="cname" select="'Organización'"/>
		<xsl:with-param name="cvalue" select="./gmd:pointOfContact/gmd:CI_ResponsibleParty/gmd:organisationName/gco:CharacterString"/>
		</xsl:call-template>
	  </xsl:for-each>
      <!--abstract is handled seperately because of text formatting-->
      <tr>
      <td class="meta-param">Resumen:</td>
      <td class="meta-value">
      <xsl:apply-templates select="./gmd:abstract"/>
      </td>
      </tr>
      
      <!-- Keywords  -->
      <xsl:choose>
      <xsl:when test="./gmd:descriptiveKeywords/gmd:MD_Keywords/gmd:keyword">
      <tr>
      <td class="meta-param">Palabras clave:</td>
        <td class="meta-value">
            <xsl:apply-templates select="./gmd:descriptiveKeywords/gmd:MD_Keywords/gmd:keyword"/>
        </td>
      </tr> 
	  <tr>
	  <td class="meta-param">Palabras clave (detalles):</td>
	  <td class="meta-value">
	  <ul class="ul1"> 
			<xsl:for-each select="./gmd:descriptiveKeywords/gmd:MD_Keywords[gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString='GEMET - INSPIRE Themes']">
				<li class="li1"> <xsl:value-of select="gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString"/> : 
				<xsl:value-of select="gmd:keyword/gco:CharacterString"/> </li>
			</xsl:for-each>
		</ul>
		<ul class="ul1"> 
			<xsl:for-each select="./gmd:descriptiveKeywords/gmd:MD_Keywords[not (gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString='GEMET - INSPIRE Themes')]">
				<li class="li1"> - <b><xsl:value-of select="gmd:keyword/gco:CharacterString"/></b></li> 
				<xsl:if test="gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString">
				[<u>vocabulario controlado</u> : <i><xsl:value-of select="gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString"/></i> -  
				<u>fecha</u> : <i><xsl:value-of select="gmd:thesaurusName/gmd:CI_Citation/gmd:date/gmd:CI_Date/gmd:date/gco:Date"/></i> - 
				<u>tipo de fecha</u> : <i><xsl:value-of select="gmd:thesaurusName/gmd:CI_Citation/gmd:date/gmd:CI_Date/gmd:dateType/gmd:CI_DateTypeCode"/></i>]
				</xsl:if>
			</xsl:for-each>
		</ul>
	  </td>
	  </tr>
      </xsl:when>
      <xsl:otherwise>
      </xsl:otherwise>
    </xsl:choose>
      
     <!--  Spatial repres --> 
      <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Type de représentation spatiale'"/>
      <xsl:with-param name="cvalue" select="./gmd:spatialRepresentationType/gmd:MD_SpatialRepresentationTypeCode"/>
      </xsl:call-template>
      
      <!-- Spatial scale -->
      <xsl:choose>
      <xsl:when test="./gmd:spatialResolution/gmd:MD_Resolution/gmd:equivalentScale/gmd:MD_RepresentativeFraction/gmd:denominator/gco:Integer">
      <tr>
      <td class="meta-param">Escala espacial:</td>
        <td class="meta-value">
            1:<xsl:apply-templates select="./gmd:spatialResolution/gmd:MD_Resolution/gmd:equivalentScale/gmd:MD_RepresentativeFraction/gmd:denominator/gco:Integer"/>
        </td>
      </tr>  
      </xsl:when>
          <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>
      
      <!-- Spatial accuracy -->
      <xsl:choose>
      <xsl:when test="./gmd:spatialResolution/gmd:MD_Resolution/gmd:distance/gco:Distance">
      <tr>
      <td class="meta-param">Escala de equivalencia en unidades de medida :</td>
        <td class="meta-value">
            <xsl:apply-templates select="./gmd:spatialResolution/gmd:MD_Resolution/gmd:distance/gco:Distance"/>
            <xsl:apply-templates select="./gmd:spatialResolution/gmd:MD_Resolution/gmd:distance/gco:Distance/@uom"/>
        </td>
      </tr>  
      </xsl:when>
          <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>
      
     
      
</table>
            <!-- License info block -->
            <xsl:apply-templates select="./gmd:resourceConstraints/gmd:MD_LegalConstraints"/>
            <xsl:apply-templates select="./gmd:extent"/>
            <xsl:apply-templates select="./gmd:pointOfContact"/>
</div>

</xsl:template>

<!-- 'dataQualityInfo block -->
<xsl:template match="gmd:DQ_DataQuality">
<div class="captioneddiv">
<h3>Información de calidad</h3>
<table class="meta"><tr></tr>
        <xsl:call-template name="tablerow">
            <xsl:with-param name="cname" select="'Tipo de recurso'"/>
            <xsl:with-param name="cvalue" select="./gmd:scope/gmd:DQ_Scope/gmd:level/gmd:MD_ScopeCode"/>
        </xsl:call-template>
        <xsl:call-template name="tablerow">
            <xsl:with-param name="cname" select="'Linaje'"/>
            <xsl:with-param name="cvalue" select="./gmd:lineage/gmd:LI_Lineage/gmd:statement/gco:CharacterString"/>
        </xsl:call-template>
        <xsl:call-template name="tablerow">
            <xsl:with-param name="cname" select="'Información sobre el proceso'"/>
            <xsl:with-param name="cvalue" select="./gmd:lineage/gmd:LI_Lineage/gmd:processStep/gmd:LI_ProcessStep/gmd:description/gco:CharacterString"/>
        </xsl:call-template>

</table>
</div>

</xsl:template>
 

<!-- 'dataQualityInfo block -->
<xsl:template match="gmd:contentInfo">
<div class="captioneddiv">
<h3>Información sobre los datos</h3>
    <!-- Raster info -->
    <xsl:apply-templates select="./gmd:MD_ImageDescription"/>
    <!-- Vector info -->
</div>
</xsl:template>

<xsl:template match="gmd:MD_ImageDescription">
<table class="meta"><tr></tr>
    <xsl:call-template name="tablerow">
      <xsl:with-param name="cname" select="'Tipo de contenido'"/>
      <xsl:with-param name="cvalue" select="./gmd:contentType/gmd:MD_CoverageContentTypeCode"/>
    </xsl:call-template>
    
    <xsl:choose>
      <xsl:when test="./gmd:dimension/gmd:MD_Band">
      <tr>
      <td class="meta-param">Bandas raster :</td>
        <td class="meta-value">    
            <xsl:apply-templates select="./gmd:dimension/gmd:MD_Band"/>
        </td>   
      </tr>  
      </xsl:when>
          <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>

</table>
</xsl:template>


<!-- Band info -->
<xsl:template match="gmd:MD_Band">
<div class="captioneddiv">
<table >
          <xsl:call-template name="tablerow">
          <xsl:with-param name="cname" select="'Valor mínimo'"/>
          <xsl:with-param name="cvalue" select="./gmd:minValue/gco:Real"/>
          </xsl:call-template>

          <xsl:call-template name="tablerow">
          <xsl:with-param name="cname" select="'Valor máximo'"/>
          <xsl:with-param name="cvalue" select="./gmd:maxValue/gco:Real"/>
          </xsl:call-template>
          
          <xsl:call-template name="tablerow">
          <xsl:with-param name="cname" select="'Valor de bit'"/>
          <xsl:with-param name="cvalue" select="./gmd:bitsPerValue/gco:Integer"/>
          </xsl:call-template>              
</table> 
</div>
</xsl:template>
 

 <!-- 'License info' block -->
  <xsl:template match="gmd:MD_LegalConstraints">
  	<xsl:if test="./gmd:useLimitation/gco:CharacterString">
      <div class="captioneddiv">
        <h3>Restricciones de uso :</h3>
        <table class="meta"><tr></tr>
        <xsl:call-template name="tablerow">
      		<xsl:with-param name="cname" select="'Tipo de restricción'"/>
      		<xsl:with-param name="cvalue" select="./gmd:useConstraints/gmd:MD_RestrictionCode"/>
      	</xsl:call-template>
      	<xsl:call-template name="tablerow">
      		<xsl:with-param name="cname" select="'Texto reglamentario'"/>
      		<xsl:with-param name="cvalue" select="./gmd:useLimitation/gco:CharacterString"/>
      	</xsl:call-template>
      	</table>
      </div>
    </xsl:if>
  </xsl:template>

<!-- 'Identification->Point of Contact' block -->
<xsl:template match="gmd:pointOfContact">
    <div class="captioneddiv">
      <h3>Punto de contacto</h3>
      <table class="meta">
        <tr>
          <td class="meta" valign="top">
            <table class="meta">
              <tr></tr>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Nombre'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:individualName/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Organización'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:organisationName/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Posición'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:positionName/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Role'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:role/gmd:CI_RoleCode/@codeListValue"/>
              </xsl:call-template>
            </table>
          </td>
          <td class="meta" valign="top">
            <table class="meta">
              <tr></tr>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Téléfono'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'facsímil'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:facsimile/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Dirección'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:deliveryPoint/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Ciudad'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:city/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Código Postal'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:postalCode/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'País'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:country/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Correo electrónico'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:address/gmd:CI_Address/gmd:electronicMailAddress/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'Téléfono'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:phone/gmd:CI_Telephone/gmd:voice/gco:CharacterString"/>
              </xsl:call-template>
              <xsl:call-template name="tablerow">
                <xsl:with-param name="cname" select="'URL del Sitio Web'"/>
                <xsl:with-param name="cvalue" select="./gmd:CI_ResponsibleParty/gmd:contactInfo/gmd:CI_Contact/gmd:onlineResource/gmd:CI_OnlineResource/gmd:linkage/gmd:URL"/>
              </xsl:call-template>
            </table>
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>


  <!-- 'Identification->Geographic box' block -->
  <xsl:template match="gmd:extent">
    <xsl:if test="./gmd:EX_Extent/gmd:geographicElement">
    <xsl:for-each select="./gmd:EX_Extent/gmd:geographicElement">
      <div class="captioneddiv">
        <h3>Extensión geográfica</h3>
        <br/>
        <table class="meta" width="100%" height="25%" align="center">
          <tr></tr>
          <tr>
            <td></td>
            <td class="meta-param" align="center">
              Límite Norte para latitud<br/>
              <font color="#000000">
                <xsl:value-of select="./gmd:EX_GeographicBoundingBox/gmd:northBoundLatitude/gco:Decimal"/>
              </font>
            </td>
            <td></td>
          </tr>
          <tr>
            <td class="meta-param" align="center">
              Límite Oeste para longitud<br/>
              <font color="#000000">
                <xsl:value-of select="./gmd:EX_GeographicBoundingBox/gmd:westBoundLongitude/gco:Decimal"/>
              </font>
            </td>
            <td></td>
            <td class="meta-param" align="center">
              Límite Este para longitud<br/>
              <font color="#000000">
                <xsl:value-of select="./gmd:EX_GeographicBoundingBox/gmd:eastBoundLongitude/gco:Decimal"/>
              </font>
            </td>
          </tr>
          <tr>
            <td></td>
            <td class="meta-param" align="center">
              Límite Sur para latitud<br/>
              <font color="#000000">
                <xsl:value-of select="./gmd:EX_GeographicBoundingBox/gmd:southBoundLatitude/gco:Decimal"/>
              </font>
            </td>
            <td></td>
          </tr>
        </table>
      </div>
    </xsl:for-each>
    </xsl:if>
  </xsl:template>
  
  <!-- 'Distribution Info' block -->
  <xsl:template match="gmd:MD_Distribution">
    <div class="captioneddiv">
      <h3>Información de distribución</h3>
      <table class="meta">
        <tr></tr>
        <xsl:for-each select="gmd:transferOptions/gmd:MD_DigitalTransferOptions/gmd:onLine/gmd:CI_OnlineResource">
          <xsl:choose>
            <xsl:when test="starts-with(./gmd:protocol/gco:CharacterString,'WWW:DOWNLOAD-') and contains(./gmd:protocol/gco:CharacterString,'http--download') and ./gmd:name/gco:CharacterString">
              <tr>
                <td class="meta-param">Descarga :</td>
                <td class="meta-value">
                  <a>
                    <xsl:attribute name="href">
                      <xsl:value-of select="gmd:linkage/gmd:URL"/>
                    </xsl:attribute>
                    <xsl:value-of select="gmd:name/gco:CharacterString"/>
                  </a>
                </td>
              </tr>
            </xsl:when>
            <xsl:when test="starts-with(./gmd:protocol/gco:CharacterString,'ESRI:AIMS-') and contains(./gmd:protocol/gco:CharacterString,'-get-image') and ./gmd:name/gco:CharacterString">
              <tr>
                <td class="meta-param">Esri ArcIms:</td>
                <td class="meta-value">
                  <a>
                    <xsl:attribute name="href">
                      <xsl:value-of select="gmd:linkage/gmd:URL"/>
                    </xsl:attribute>
                    <xsl:value-of select="gmd:name/gco:CharacterString"/>
                  </a>
                </td>
              </tr>
            </xsl:when>
            <xsl:when test="starts-with(./gmd:protocol/gco:CharacterString,'OGC:WMS-') and contains(./gmd:protocol/gco:CharacterString,'-get-capabilities') and ./gmd:name/gco:CharacterString">
              <tr>
                <td class="meta-param">OGC-WMS Capabilities:</td>
                <td class="meta-value">
                  <a>
                    <xsl:attribute name="href">
                      <xsl:value-of select="gmd:linkage/gmd:URL"/>
                    </xsl:attribute>
                    <xsl:value-of select="gmd:name/gco:CharacterString"/>
                  </a>
                </td>
              </tr>
            </xsl:when>
          </xsl:choose>
        </xsl:for-each>
		<tr>
		<td class="meta-param">Formatos de distribución :</td>
		<td class="meta-value">
		<ul class="ul1"> 
			<xsl:for-each select="gmd:distributionFormat/gmd:MD_Format">
				<li class="li1"> - <xsl:value-of select="gmd:name/gco:CharacterString"/> 
					<xsl:if test="gmd:version/gco:CharacterString and gmd:version/gco:CharacterString!=''">
						    (version : <xsl:value-of select="gmd:version/gco:CharacterString"/>)
					</xsl:if>	
					<xsl:if test="gmd:version/gco:CharacterString and gmd:version/gco:CharacterString=''">
					(versión desconocida)</xsl:if>					
				</li>
			</xsl:for-each>
		</ul>
		</td>
		</tr>
      </table>
    </div>
  </xsl:template>

</xsl:stylesheet>
